<?php

namespace App\Controllers;

use App\Models\AdminModel;
use App\Models\AdminPermissionModel;
use App\Models\AdminRoleModel;
use App\Models\AdminModuleModel;
use App\Models\AdminRoleModuleModel;

class AdminPermission extends BaseController
{

	public function updateAdminPermission($adminID)
	{
		if (!$this->request->isAjax()) {
			$adminPermissionModel = new AdminPermissionModel();
			$adminRoleModel = new AdminRoleModel();

			$adminPermissionData = $adminPermissionModel->getByAdminID($adminID);

			$arrPermission = [];

			if(@$adminPermissionData){
				foreach ($adminPermissionData as $key => $value) {
					$arrPermission[] = $value->role_id;
				}
			}

			$adminRoleData = $adminRoleModel->getAll($adminID);

			$data = [
				'title' => lang('Menu.user.admin.main'),
				'menu' => 'admin',
				'data_role' => (isset($adminRoleData))? $adminRoleData : [], 
				'data_permission' => $arrPermission,
				'admin_id' => $adminID
			];

			return view('admin-permission/index', $data);
		}

		if (!$this->validate([
            'role_id.0'             => ['label' => 'Role', 'rules' => 'required' ],
        ])) {
			$msg = [
                'error' => $this->validation->listErrors(),
            ];
            return json_encode($msg);
		}

		$roleID = $this->request->getPost('role_id');

        $adminPermissionModel = new AdminPermissionModel();
		$adminPermissionDelete = $adminPermissionModel->deleteAdminPermission($adminID, $this->session->get('id'));
		foreach ($roleID as $key => $value) {
			$data = [
	            'ap_admin_id'           => $adminID,
	            'ap_role_id'            => $value,
	            'ap_insert_admin_id'    => $this->session->get('id'),
	            'ap_active'             => 1
	        ];

			$adminPermissionData = $adminPermissionModel->addAdminPermission($data);
		}

		if ($adminPermissionData && $adminPermissionDelete) {
			$data = [
				'success'=> lang('Validation.success_add'),
				'redirect' => 'admin'
			];
			return json_encode($data);
		}
	}
}
