<?php

namespace App\Controllers;
use App\Models\OrderModel;
use App\Models\OrderItemModel;
use App\Models\BatchItemTaskModel;
use App\Models\BatchItemModel;
use App\Models\BatchItemOutputModel;

class Dashboard extends BaseController
{
	public function index()
	{
		$data = [
			'title' => 'Dashboard',
			'menu' => 'dashboard',
		];

		return view('dashboard/dashboard_content_view', $data);
	}


	public function orderNote(){

		$note = $this->request->getVar('note', FILTER_SANITIZE_STRING);

		$note = str_replace('\\', '/', $note);

		$orderModel = new OrderModel();
		$orderData = $orderModel->getByNota($note);

		if (empty($orderData)) {
			return json_encode(['html' => '<center>Nota Tidak Ditemukan !!!</center>']);
		}

		$orderItemModel = new OrderItemModel();
		$orderItemData = $orderItemModel->getByOrderID(@$orderData[0]->id);

		$html = '<div class="p-2">
					<div class="row">
						<div class="col-md-12">
							<h5>Identitas Pelanggan</h5>
						</div>
						<div class="col-md-6">
							<table>
								<tr>
									<td>Nama</td>
									<td> &nbsp;&nbsp; :&nbsp;'.$orderData[0]->customer_name.'</td>
								</tr>
								<tr>
									<td>Alamat</td>
									<td> &nbsp;&nbsp; :&nbsp;'.@$orderData[0]->customer_address.'</td>
								</tr>
								<tr>
									<td>Telp</td>
									<td> &nbsp;&nbsp; :&nbsp;'.@$orderData[0]->customer_phone.'</td>
								</tr>
							</table>
						</div>
						<div class="col-md-6">
							<table>
								<tr>
									<td>Nota</td>
									<td> &nbsp;&nbsp; : &nbsp;'.$orderData[0]->note.'</td>
								</tr>
								<tr>
									<td>Tanggal Order</td>
									<td> &nbsp;&nbsp; : &nbsp;'.getTanggal($orderData[0]->date).'</td>
								</tr>
								<tr>
									<td>Jatuh Tempo</td>
									<td> &nbsp;&nbsp; : &nbsp;'.getTanggal($orderData[0]->due_date).'</td>
								</tr>
								<tr>
									<td>Status</td>
									<td> &nbsp;&nbsp; : &nbsp;'.$orderData[0]->status.'</td>
								</tr>
							</table>
						</div>
					</div>';

					foreach ($orderItemData as $key => $value) {
						$html .= '<div class="border border-2 mt-4 p-2">
								<div class="row">
									<div class="col-md-6">
										<table>
											<tr>
												<td>SKU</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->sku.'</td>
											</tr>
											<tr>
												<td>Barang</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->name.'</td>
											</tr>
											<tr>
												<td>Jumlah</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->quantity.'</td>
											</tr>
											<tr>
												<td>Berat</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->weight.'</td>
											</tr>
										</table>
									</div>
									<div class="col-md-6">
										<table>
											<tr>
												<td>Kadar Emas</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->gc_name.'</td>
											</tr>
											<tr>
												<td>Warna Emas</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->gt_name.'</td>
											</tr>
											<tr>
												<td>Status</td>
												<td> &nbsp;&nbsp; : &nbsp '.$value->order_item_status.'</td>
											</tr>
										</table>
									</div>
									<div class="col-md-12">
										<a target="_blank" href="'.base_url('dashboard/order-item-detail/'.$value->id).'" class="btn btn-primary btn-sm float-end" data-id="'.$value->id.'">Detail</a>
									</div>
								</div>
							</div>';
					}

				$html .= '</div>';

		return json_encode(['html' => $html]);
	}

 
	public function orderItemDetail($id){

		$orderItemModel = new OrderItemModel();
		$orderItemData = $orderItemModel->getByID($id);

		// dd($orderItemData);

		$batchItemModel = new BatchItemModel();
		$batchItemData = $batchItemModel->getByOrderItemID($id);

		$orderModel = new OrderModel();
		$orderData = $orderModel->getByID($orderItemData->order_id);

		$batchItemTaskModel = new BatchItemTaskModel();
		$batchItemTaskData = $batchItemTaskModel->getAllTracking(['where' => ' AND bit_1.bit_bi_id="'.@$batchItemData[0]->id.'" AND bit_1.bit_input_quantity > 0 ', 'orderby' => ' bit_1.bit_id ASC ']);

		$bitData = [];
		foreach ($batchItemTaskData as $key => $value) {
			$bitData[$value->group_note][] = $value;
		}

		$batchItemOutputModel = new BatchItemOutputModel();

		$batchItemOutputData = $batchItemOutputModel->getAll(['where' => ' AND bio_oi_id='.$id.' AND bio_active=1 ',  'orderby' => ' bio_id ASC ']);

		$data = [
			'title' => lang('Menu.order.batch-item-task.main'),
			'menu' => 'dashboard',
			'batch_item_task' => $bitData,
			'batch_item_output_data' => $batchItemOutputData, 
			'order_item_data' => $orderItemData,
			'order_data' => $orderData
		];
		return view('dashboard/order-detail', $data);

	}
}
