<?php
namespace App\Controllers;

use App\Models\OrderModel;
use App\Models\OrderItemModel;
use App\Models\BatchModel;
use App\Models\BatchItemModel;
use App\Models\BatchItemTaskModel;
use App\Models\BatchItemRequestModel;
use App\Models\BatchItemOutputModel;
use App\Models\BatchItemGroupNoteModel;

class Worker extends BaseController {
	
	public function notificationWhatsApp(){

		$orderModel = new OrderModel();
		$orderDataTodayDueDate = $orderModel->getAll([
			'where'=> ' AND order_status IN ("Proses", "New") AND order_due_date="'.date('Y-m-d').'" AND order_active=1',
			'orderby'=> 'orders.order_due_date'
		]);

		$htmlTodayDueDate = 'ORDER JATUH TEMPO
';
		foreach ($orderDataTodayDueDate as $key => $value) {
			$htmlTodayDueDate .= $value->note .' ('.getTanggal($value->due_date).')
';
		}

		$tomorrow = date("Y-m-d", strtotime("+1 day"));
		$orderDataHmin1Date = $orderModel->getAll([
			'where'=> ' AND order_status IN ("Proses", "New") AND order_due_date="'.$tomorrow.'" AND order_active=1',
			'orderby'=> 'orders.order_due_date'
		]);
		
		$htmlHmin1Date = '

ORDER JATUH TEMPO H-1

';

		foreach ($orderDataHmin1Date as $key => $value) {
			$htmlHmin1Date .= $value->note .' ('.getTanggal($value->due_date).') ';
		}
		
		$result = sendWhatsApp('088232340119', $htmlTodayDueDate.$htmlHmin1Date);
		// $result = sendWhatsApp('08122680110', 'Hello World');
		// $result = sendWhatsApp('085736157112', 'Hello World');

		return $result;
	}

	public function index(){
		return "1";
	}

	public function approveBatchItemRequest(){

		$authorizationHeader = trim($this->request->getHeader("Authorization"));
        $this->accessToken = "";
        if (!empty($authorizationHeader)) {
            if (preg_match('/Bearer\s(\S+)/', $authorizationHeader, $matches)) {
                $this->accessToken = $matches[1];
            }
        }

        if ($this->accessToken != GUDANG_BATU_TOKEN) {
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.unauthorizedNoAccessToken')], $this->benchmark);
        }

        $batchCode = $this->request->getPost('batch_code', FILTER_SANITIZE_STRING);

        $batchItemModel = new BatchItemModel();

        $batchData = $batchItemModel->getAll(['where' => 'AND batches.batch_code="'.$batchCode.'" AND bi_active=1 ']);
		
		$batchItemRequestModel = new BatchItemRequestModel();

        if(empty($batchData)){
        	$batchCodeEx = explode('-', $batchCode);
        	$bitID = end($batchCodeEx);
        	$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Approved',
				'bir_active' => 1
			];

			$result = $batchItemRequestModel->updateBatchItemRequest($data, $bitID);

        }else{


	        $biData = [];
	        foreach ($batchData as $key => $value) {
	        	$biData[] = $value->id;
	        }

			$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Approved',
				'bir_active' => 1
			];
			
			$result = $batchItemRequestModel->updateBatchItemRequestByBatchBulk($data, $biData);
        }


		if($result){
            return getResponse(200, "success", [(array)$result], $this->benchmark);
        }else{
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.dataNotFound')], $this->benchmark);
        }
	}

	public function cencelBatchItemRequest(){

		$authorizationHeader = trim($this->request->getHeader("Authorization"));
        $this->accessToken = "";
        if (!empty($authorizationHeader)) {
            if (preg_match('/Bearer\s(\S+)/', $authorizationHeader, $matches)) {
                $this->accessToken = $matches[1];
            }
        }

        if ($this->accessToken != GUDANG_BATU_TOKEN) {
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.unauthorizedNoAccessToken')], $this->benchmark);
        }

        $batchCode = $this->request->getPost('batch_code', FILTER_SANITIZE_STRING);

        $batchItemModel = new BatchItemModel();
        $batchModel = new BatchModel();

        $batchData = $batchItemModel->getAll(['where' => 'AND batches.batch_code="'.$batchCode.'" AND bi_active=1 ']);
		
		$batchItemRequestModel = new BatchItemRequestModel();

		$result = false;

        if(empty($batchData)){
        	$batchCodeEx = explode('-', $batchCode);
        	$bitID = end($batchCodeEx);
        	$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Cancelled',
				'bir_active' => 1
			];

			$result = $batchItemRequestModel->updateBatchItemRequest($data, $bitID);

        }else{

        	$data = [
				'batch_status' 			=> 'Cancelled',
				'batch_remark' 			=> 'Cancel By Gudang Batu ',
				'batch_update_admin_id' => $this->session->get('id'),
				'batch_update_at'	 	=> getCurrentTime(),
	            'batch_active'          => 1
	        ];

			$batchUpdate = $batchModel->updateBatches($data, $batchData[0]->batch_id);

	        $biData = [];
	        foreach ($batchData as $key => $value) {
	        	$biData[] = $value->id;
	        }

			$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Cancelled',
				'bir_active' => 1
			];
			
			$result = $batchItemRequestModel->updateBatchItemRequestByBatchBulk($data, $biData);
        }


		if($result){
            return getResponse(200, "success", [(array)$result], $this->benchmark);
        }else{
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.dataNotFound')], $this->benchmark);
        }
	}

	public function tester(){
		$code = $this->request->getVar('code');
		$batchModel = new BatchModel();
		$batchData = $batchModel->getTester($code);

		dd($batchData);
	}


	public function repairBit(){

		$batchItemModel = new BatchItemModel();
		$batchItemData = $batchItemModel->repairBatchItem();

		$batchItemTaskModel = new BatchItemTaskModel();
		$batchItemOutputModel = new BatchItemOutputModel();
		$orderItemModel = new OrderItemModel();

		foreach ($batchItemData as $key => $value) {

			$bitData = $batchItemTaskModel->getAll(['where' => ' AND bit_bi_id="'.$value->id.'" ', 'orderby' => ' bit_group_note, bit_id DESC' ]);

			$quantity = $bitData[0]->output_quantity;
			$weight = $bitData[0]->output_weight;

			// $batchItemOutputModel->getAll(['where' => ' AND bio_is_melt=0 AND bio_is_repair=1 AND bio_bi_id="'.$bitData[0]->bi_id.'" ']);

			$data = [
				'bio_bi_id'=> @$bitData[0]->bi_id,
				'bio_oi_id'=> @$bitData[0]->oi_id,
				'bio_bit_id' => @$bitData[0]->id,
				'bio_item_id'=> @$bitData[0]->item_id,
				'bio_is_melt'=> 0,
				'bio_is_repair'=> 1,
				'bio_note'=> $this->bioNote(date('Y-m-d')),
				'bio_item_sku' => @$bitData[0]->item_sku,
				'bio_item_name' => @$bitData[0]->item_name,
				'bio_item_quantity' =>$quantity,
				'bio_item_weight' => $weight,
				'bio_insert_at' => @$bitData[0]->insert_at,
				'bio_insert_admin_id' => $this->session->get('id')
			];

		
			$result = $batchItemOutputModel->addBatchItemOutput($data);

			$batchItemID = $value->id;

			$batchItemOutputData = $batchItemOutputModel->getAll(['select' => ' SUM(bio_item_quantity) as sum_item_quantity, SUM(bio_item_weight) as sum_item_weight ', 'where' => ' AND bio_bi_id='.$batchItemID.' AND bio_is_melt=0 AND bio_active=1  ', 'orderby' => ' bio_id ASC ']);

			$completedQuantity = @$batchItemOutputData[0]->sum_item_quantity;
			$completedWeight = @$batchItemOutputData[0]->sum_item_weight;

			$dataOi = [
				'oi_status' => 'Completed',
	            'oi_update_admin_id' => $this->session->get('id'),
	            'oi_completed_date' => date('Y-m-d'),
	            'oi_completed_quantity' => $completedQuantity,
	            'oi_completed_weight' => $completedWeight,
	            'oi_update_at' => getCurrentTime(),
	            'oi_active' => 1
			];
			
			$orderItemData = $orderItemModel->updateOrderItem($dataOi, @$bitData[0]->oi_id);

			$batchItemModel = new BatchItemModel();
			$dataBi = [
				'bi_completed_quantity' => $completedQuantity,
				'bi_completed_weight' => $completedWeight,
	            'bi_update_admin_id' => $this->session->get('id'),
	            'bi_update_at' => getCurrentTime(),
	            'bi_active' => 1
			];
			$batchItemData = $batchItemModel->updateBatchItem($dataBi, @$bitData[0]->bi_id);

			$batchItemGroupNoteModel = new BatchItemGroupNoteModel();
			$dataBign = [
				'bign_bi_id' => @$bitData[0]->bi_id,
				'bign_bit_group_note' => @$bitData[0]->item_id,
				'bign_completed_quantity' => $completedQuantity,
				'bign_completed_weight' => $completedWeight,
				'bign_on_id' => NULL,
				'bign_status'=> 'New',
				'bign_insert_at' => @$bitData[0]->insert_at, 
				'bign_insert_admin_id' => $this->session->get('id'),
				'bign_update_at' => getCurrentTime(),
				'bign_update_admin_id' => $this->session->get('id'),
			];
			$batchItemGroupNoteData = $batchItemGroupNoteModel->addBatchItemGroupNote($dataBign);


		}

	}


	public function bioNote($data){

		$batchItemOutputModel = new BatchItemOutputModel();

		$bitNota = $batchItemOutputModel->setNote();


		if ($bitNota) {
			$number = $bitNota[0]->total;
	        $number = ((int)$number) + 1;
	        $code = str_pad($number, 5, "0", STR_PAD_LEFT);
		}else{
			$code = '00001';
		}

		$dateEx = explode('-', date('Y-m-d'));

		return 'ONBP/'.$dateEx[2].$dateEx[1].substr($dateEx[0], -2) .'/'.$code;
	}
}