<?php namespace App\Models;

class AdminRoleModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else        
            $query = 'SELECT ar_id as "id", ar_name as "name", ar_slug as "slug", ar_description as "description", ar_insert_at as "insert_at" ';

        $query .= ' FROM admin_roles
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND ar_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY ar_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        
            

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($adminRoleID){
        $adminRoles = $this->db->table('admin_roles');
        $adminRoles->select('ar_id as "id", ar_name as "name", ar_slug as "slug", ar_description as "description", ar_insert_at as "insert_at" ');
        $adminRoles->where('ar_id', $adminRoleID);
        $adminRoles->where('ar_active', 1);

        $result = $adminRoles->get()->getRow();

        return $result;
    }

    public function getBySlug($adminRoleSlug){
        $adminRoles = $this->db->table('admin_roles');
        $adminRoles->select('ar_id as "id", ar_name as "name", ar_slug as "slug", ar_description as "description", ar_insert_at as "insert_at" ');
        $adminRoles->where('ar_slug', $adminRoleSlug);
        $adminRoles->where('ar_active', 1);

        $result = $adminRoles->get()->getRow();

        return $result;
    } 

    public function addAdminRole($data){

        $adminRoles = $this->db->table('admin_roles');
        $adminRoles->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function updateAdminRole($data, $roleID){
        
        $this->db->table('admin_roles')->where('ar_id',$roleID)->update($data);
        $param = array(
            'where' => ' AND ar_id="'.$roleID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];
        

        return $result;
        
    }

    public function deleteAdminRole($roleID, $deleteAdminID ){
        $data = [
            'ar_delete_at'       => getCurrentTime(),
            'ar_delete_admin_id' => $deleteAdminID,
            'ar_active'          => 0
        ];

        $this->db->table('admin_roles')->where('ar_id',$roleID)->update($data);
        $param = array(
            'where' => ' AND ar_id="'.$roleID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}