<?php namespace App\Models;

class CategoryModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT category_id as "id", category_code as "code", category_name as "name",  category_insert_at as "insert_at" ';

        $query .= ' FROM categories
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND category_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY category_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND category_active="1" AND category_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function getByID($categoryID){
        $categories = $this->db->table('categories');
        $categories->select('category_id as "id", category_code as "code", category_name as "name", category_insert_at as "insert_at" ');
        $categories->where('category_id', $categoryID);
        $categories->where('category_active', 1);

        $result = $categories->get()->getRow();

        return $result;
    }

    public function addCategory($data){
        $categories = $this->db->table('categories');
        $categories->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function updateCategory($data, $categoryID){

        $this->db->table('categories')->where('category_id',$categoryID)->update($data);
        $param = array(
            'where' => ' AND category_id="'.$categoryID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteCategory($categoryID, $deleteAdminID ){
        $data = [
            'category_delete_at'       => getCurrentTime(),
            'category_delete_admin_id' => $deleteAdminID,
            'category_active'          => 0
        ];

        $this->db->table('categories')->where('category_id',$categoryID)->update($data);
        $param = array(
            'where' => ' AND category_id="'.$categoryID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}