<?php namespace App\Models;

class TaskModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT task_id as "id", task_code as "code", task_name as "name", task_insert_at as "insert_at", task_input_notification_list as "input_notification_list", task_output_notification_list as "output_notification_list" ';

        $query .= ' FROM tasks
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND task_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY task_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function inputFieldGetAll($param = []){
        $query = 'SELECT if_id as "id", if_name as "name", if_datatype as "datatype", if_options as "options" ';

        $query .= ' FROM input_fields WHERE 1 ';

        if (isset($param['type'])) {
             $query .= ' AND if_type IN ("'.$param['type'].'", "All") ';
        }


        $query .= ' ORDER BY name';
        return $this->db->query($query)->getResult();
    }

    public function taskInputFieldGetByTask($taskID, $type){
        $query = 'SELECT task_input_fields.tif_id as "id", task_input_fields.tif_task_id as "task_id", task_input_fields.tif_if_id as "input_field_id", task_input_fields.tif_is_required as "is_required", input_fields.if_name as "name", input_fields.if_datatype as "datatype", input_fields.if_options as "options" FROM task_input_fields LEFT JOIN input_fields ON input_fields.if_id=task_input_fields.tif_if_id WHERE task_input_fields.tif_task_id='.$taskID.' AND task_input_fields.tif_type="'.$type.'"  AND tif_active=1 ORDER BY tif_order';

        return $this->db->query($query)->getResult();
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND task_active="1" AND task_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function getByID($taskID){
        $param = array(
            'where' => ' AND task_active="1" AND task_id="'.$taskID.'" ',
        );
        $result = $this->getAll($param);
        
        return $result[0];
    }

    public function addTask($data){
        $tasks = $this->db->table('tasks');
        $tasks->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addTaskInputFieldBulk($data){
        $tasks = $this->db->table('task_input_fields');
        $tasks->insertBatch($data);

        return $data;
    }

    public function updateTaskInputFieldBulk($data){

        $tasks = $this->db->table('task_input_fields');
        $tasks->updateBatch($data, 'tif_id');

        return $data;
    }

    public function addTaskHistory($data){
        $tasks = $this->db->table('task_histories');
        $tasks->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function updateTask($data, $taskID){

        $this->db->table('tasks')->where('task_id',$taskID)->update($data);
        $param = array(
            'where' => ' AND task_id="'.$taskID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteTask($taskID, $deleteAdminID ){
        $data = [
            'task_delete_at'       => getCurrentTime(),
            'task_delete_admin_id' => $deleteAdminID,
            'task_active'          => 0
        ];

        $this->db->table('tasks')->where('task_id',$taskID)->update($data);
        $param = array(
            'where' => ' AND task_id="'.$taskID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteTaskInputField($taskID, $deleteAdminID){
        $data = [
            'tif_delete_at'       => getCurrentTime(),
            'tif_delete_admin_id' => $deleteAdminID,
            'tif_active'          => 0
        ];

        $result = $this->db->table('task_input_fields')->where('tif_task_id',$taskID)->update($data);

        return $result;
        
    }

}