<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1"><?= lang('Menu.user.role.permission') ?></small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/admin" class="btn btn-sm btn-secondary" >Back</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-12">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
								<form action="" class="submit" method="post">
									<table class="table table-striped table-row-bordered gy-5 gs-7">
										<thead>
											<tr>
												<th>
													<input type="checkbox" id="select-all" name="select_all">
												</th>
												<th>Name</th>
												<th>Description</th>
											</tr>
										</thead>
										<tbody>
											<?php if (isset($data_role)): ?>
												<?php foreach ($data_role as $key => $value): ?>
												<tr>
													<td>
														<div class="form-group my-3 col-md-6">
															<input <?= (in_array($value->id, $data_permission))? 'checked=""' : '' ?>  type="checkbox" value="<?= $value->id ?>" name="role_id[]" class="mt-1">
														</div>
													</td>
													<td>
														<?= $value->name ?>
													</td>
													<td>
														<?= $value->description ?>
													</td>
												</tr>
											<?php endforeach ?>		
											<?php endif ?>
										</tbody>
									</table>
								<button class="btn btn-primary button mt-3">Simpan</button>	
								</form>
							</div>
							<!--end: Card Body-->
						</div>
						<!--end: List Widget 5-->
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
</div>
<!--end::Content-->

<!-- <script type="text/javascript">
	function checkRole(id){

    $.ajax({
          type : 'post',
          url : '',
          data : {role_id:id},
          dataType : 'JSON',
          // processData: false,
          // contentType: false,
          beforeSend : function(){
            $('.loading').attr('data-kt-indicator', 'on');
            $('.loading').html('<span class="indicator-progress">\
                        Loading <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            $('.loading').removeAttr('data-kt-indicator');
          },
          success: function(response){
             if (response.error) {
              alertToastr('error', response.error);
            }else if(response.success){
              alertToastr('success', response.success);
            }

          },
          error: function (xhr, ajaxOptions, thrownError){
            console.log(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }

        });
	}
</script> -->
<?= $this->endSection() ?>

<?= $this->section('js') ?>
<script type="text/javascript">
	  $('#select-all').click(function(event) {
	    if (this.checked) {
	      // Iterate each checkbox
	      $(':checkbox').each(function() {
	        this.checked = true;
	      });
	    } else {
	      $(':checkbox').each(function() {
	        this.checked = false;
	      });
	    }
	  });
</script>
<?= $this->endSection() ?>