<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Tambah</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/order" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<form action="" class="submit2" enctype="multipart/form-data">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
									<div class="form-group my-3 col-md-7">
										<label>Pelanggan <span class="text-danger">*</span></label>
										<select name="customer_id" class="form-control mt-1" placeholder="">
											<option value="">-- Pilih --</option>
											<?php foreach ($data_customer as $key => $value): ?>
												<option value="<?= $value->id ?>"><?= $value->name ?> - <?= $value->code ?></option>
											<?php endforeach ?>
										</select>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Tanggal Mulai <span class="text-danger">*</span></label>
										<input type="date" name="date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Tanggal Batas Waktu</label>
										<input type="date" name="due_date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Tanggal Batas Waktu Cor <span class="text-danger">*</span></label>
										<input type="date" name="start_due_date" value="" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Total Request Order</label>
										<input type="text" name="request_total" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Keterangan Order</label>
										<input type="text" name="request_description" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Deskripsi</label>
										<input type="text" name="description" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-8">
										<label>Kode Barang / SKU <span class="text-danger">*</span></label>
										<div class="row">
											<div class="col-md-11">
												<input type="text" name="item_code" class="form-control mt-1" placeholder=""/>
											</div>
											<div class="col-md-1">
												<button onclick="itemCode()" type="button" class="btn btn-success mt-1">Tambah</button>
											</div>
										</div>
									</div>
								</div>
								<!--end: Card Body-->
							</div>
							<div class="card" id="card-item-empty">
									<div class="card-body">
										<center><p>Barang 
										Kosong</p></center>
									</div>
							</div>
							<div id="item-list">
							
							</div>
						<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
						<!--end: List Widget 5-->
						</form> 
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->

<?= $this->endSection() ?>

<?= $this->section('js') ?>
	<script type="text/javascript">

	let noindex = 0;

	var itemArray=[];

		$("#item-list").on('click', '.remove-item', function(e) {
				var item_code = $(this).data('item_code');

				var arrayWithoutI = []

				for (let i = 0; i < itemArray.length; i++) {
				    if (itemArray[i] != item_code) {
				        arrayWithoutI.push(itemArray[i]);
				    }
				}


				itemArray = arrayWithoutI;

        var yes = confirm('Are you sure delete this?');
        if (yes) {
            $(this).parents('.item-card').remove();
        } else {
            return false;
        }
    })
		
	function itemCode(){
		$('#card-item-empty').html('');

		let item_code = $("input[name='item_code']").val();

		if (itemArray.includes(item_code)) {
			return alert('Barang yang sama sudah dimasukkan');
		}

		itemArray.push(item_code);

		if (item_code == '') {

			return alert('Masukkan kode barang !!!')

			$('#item-list').append('<div class="card card-xxl-stretch mb-5 item-card">\
				<div class="card-body">\
					<div class="row">\
					<div class="col-md-11">\
					</div>\
					<div class="col-md-1">\
						<button type="button" style="margin-left:20px" data-item_code="'+item_code+'" class="btn btn-danger btn-icon btn-sm remove-item"><i class="fa fa-trash"></i></button>\
					</div>\
						<div class="form-group my-3 col-md-4">\
							<input type="hidden" name="id['+noindex+']" value="">\
							<label>SKU</label>\
							<input type="text" name="sku['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<input type="hidden" name="id['+noindex+']" value="">\
							<label>Nama</label>\
							<input type="text" name="name['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Kategori</label>\
							<select name="category_id['+noindex+']" class="form-control mt-1" placeholder="">\
								<option value="">-- Pilih --</option>\
								<?php foreach ($data_category as $key => $value): ?>
									<option value="<?= $value->id ?>"><?= $value->name ?></option>\
								<?php endforeach ?>
							</select>\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Kadar Emas</label>\
							<select name="gc_id['+noindex+']" class="form-control mt-1" placeholder="">\
								<option value="">-- Pilih --</option>\
								<?php foreach ($data_gold_content as $key => $value): ?>
									<option value="<?= $value->id ?>"><?= $value->name ?></option>\
								<?php endforeach ?>
							</select>\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Warna Emas</label>\
							<select name="gt_id['+noindex+']" class="form-control mt-1" placeholder="">\
								<option value="">-- Pilih --</option>\
								<?php foreach ($data_gold_type as $key => $value): ?>
									<option value="<?= $value->id ?>"><?= $value->name ?></option>\
								<?php endforeach ?>
							</select>\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Berat</label>\
							<input type="text" name="weight['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Ukuran</label>\
							<select name="size_id['+noindex+']" class="form-control mt-1" placeholder="">\
								<option value="">-- Pilih --</option>\
								<?php foreach ($data_size as $key => $value): ?>
									<option value="<?= $value->id ?>"><?= $value->name ?></option>\
								<?php endforeach ?>
							</select>\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Tipe Batu</label>\
							<input type="text" name="stone_type['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Quantity</label>\
							<input type="number" name="quantity['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>No Model</label>\
							<input type="text" name="print_no['+noindex+']" class="form-control mt-1" placeholder="">\
						</div>\
						<div class="form-group my-3 col-md-4">\
							<label>Gambar (Max 3 image & Max size 4 MB)</label>\
							<input type="file" name="image'+noindex+'[]" multiple="true" class="form-control mt-1 image" accept="image/*" placeholder="">\
						</div>\
				</div>\
			</div>');

			noindex = noindex+1;
		}else{

			$.ajax({
          type : 'post',
          url : "<?= base_url(); ?>/order/create?act=addItemOrder",
          data : {item_code:item_code, noindex:noindex},
          dataType : 'JSON',
          success: function(response){
             if (response.error) {
              alertToastr('error', response.error);
            }else if(response.success){
              $('#item-list').append(response.success)
              noindex = noindex+1;
            }

          },
          error: function (xhr, ajaxOptions, thrownError){
            alert(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }

        });
		}

		$("input[name='item_code']").val('');
	}


	$('.submit2').submit(function(e){    
    e.preventDefault();

    var data = new FormData(this);
	$.each($(".image").files, function(i, files) {
		$.each(files, function(idx, file) {
	    	data.append('image'+idx, file);
		})
	});

	// var	project_thumbnail = $(".image").prop("files")[0];

	// var data = new FormData( $("#general_form")[0] );
	// 	data.append('image',project_thumbnail);

    var btn = $('.button').html();
    
    $.ajax({
          type : 'post',
          url : $(this).attr('action'),
          data : data,
          dataType : 'JSON',
          processData: false,
          contentType: false,
          beforeSend : function(){
            $('.button').attr('data-kt-indicator', 'on');
            $('.button').attr('disabled', '');
            $('.button').html('<span class="indicator-progress">\
                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            $('.button').removeAttr('disabled', '');
            $('.button').removeAttr('data-kt-indicator');
            $('.button').html(btn);
          },
          success: function(response){
             if (response.error) {
              alertToastr('error', response.error);
            }else if(response.success){
              alertToastr('success', response.success);
            }

            if (response.redirect) {
              window.location.href = '<?= base_url() ?>/'+response.redirect
            }else{
              $('#kt_datatable').DataTable().ajax.reload();
            }

          },
          error: function (xhr, ajaxOptions, thrownError){
            alert(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }

        });
  });


</script>
<?= $this->endSection() ?>