<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Tambah</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<a href="<?= base_url() ?>/task" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<div class="col-md-12">
						<form action="" class="submit">
							<div class="card card-xxl-stretch mb-5">
								<div class="card-body">
									<div class="form-group my-3 col-md-6">
										<label>Nama <?= $title ?></label>
										<input type="text" name="name" class="form-control mt-1" placeholder=""/>
									</div>

									<div class="form-group my-3 col-md-6">
										<label>List Input</label>
									</div>
									<table class="table table-striped table-bordered gs-7">
										<thead>
											<tr>
												<th>Urutan</th>
												<th><input type="checkbox" id="select-all1" name=""></th>
												<th>Nama</th>
												<th>Tipe Data</th>
												<th>Harus Diisi</th>
											</tr>
										</thead>
										<tbody class="draggable-zone">
											<?php foreach ($input_field_input as $key => $value): ?>
											<tr class="draggable">
												<td>
													<a href="#" class="btn btn-icon btn-sm btn-hover-light-primary draggable-handle">
														<!--begin::Svg Icon | path: icons/duotone/Text/Menu.svg-->
														<span class="svg-icon svg-icon-2x">
															<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
																<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
																	<rect x="0" y="0" width="24" height="24" />
																	<rect fill="#000000" x="4" y="5" width="16" height="3" rx="1.5" />
																	<path d="M5.5,15 L18.5,15 C19.3284271,15 20,15.6715729 20,16.5 C20,17.3284271 19.3284271,18 18.5,18 L5.5,18 C4.67157288,18 4,17.3284271 4,16.5 C4,15.6715729 4.67157288,15 5.5,15 Z M5.5,10 L18.5,10 C19.3284271,10 20,10.6715729 20,11.5 C20,12.3284271 19.3284271,13 18.5,13 L5.5,13 C4.67157288,13 4,12.3284271 4,11.5 C4,10.6715729 4.67157288,10 5.5,10 Z" fill="#000000" opacity="0.3" />
																</g>
															</svg>
														</span>
														<!--end::Svg Icon-->
													</a>
												</td>
												<td><input type="checkbox" value="<?= $value->id ?>" class="select1" name="input[]"></td>
												<td><?= $value->name ?></td>
												<td><?= $value->datatype ?></td>
												<th>
													<input type="checkbox" name="input_required[<?= $value->id ?>]" value="1">
												</th>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>


									<div class="form-group my-3 col-md-6">
										<label>List Output</label>
									</div>
									<table class="table table-striped table-bordered gs-7">
										<thead>
											<tr>
												<th>Urutan</th>
												<th><input type="checkbox" id="select-all2" name=""></th>
												<th>Nama</th>
												<th>Tipe Data</th>
												<th>Harus Diisi</th>
											</tr>
										</thead>
										<tbody class="draggable-zone">
											<?php foreach ($input_field_output as $key => $value): ?>
											<tr class="draggable">
												<td>
													<a href="#" class="btn btn-icon btn-sm btn-hover-light-primary draggable-handle">
														<!--begin::Svg Icon | path: icons/duotone/Text/Menu.svg-->
														<span class="svg-icon svg-icon-2x">
															<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
																<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
																	<rect x="0" y="0" width="24" height="24" />
																	<rect fill="#000000" x="4" y="5" width="16" height="3" rx="1.5" />
																	<path d="M5.5,15 L18.5,15 C19.3284271,15 20,15.6715729 20,16.5 C20,17.3284271 19.3284271,18 18.5,18 L5.5,18 C4.67157288,18 4,17.3284271 4,16.5 C4,15.6715729 4.67157288,15 5.5,15 Z M5.5,10 L18.5,10 C19.3284271,10 20,10.6715729 20,11.5 C20,12.3284271 19.3284271,13 18.5,13 L5.5,13 C4.67157288,13 4,12.3284271 4,11.5 C4,10.6715729 4.67157288,10 5.5,10 Z" fill="#000000" opacity="0.3" />
																</g>
															</svg>
														</span>
														<!--end::Svg Icon-->
													</a>
												</td>
												<td><input class="select2" value="<?= $value->id ?>" type="checkbox" name="output[]"></td>
												<td><?= $value->name ?></td>
												<td><?= $value->datatype ?></td>
												<td><input type="checkbox" name="output_required[<?= $value->id ?>]" value="1"></td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>


									<div class="form-group my-3 col-md-6">
										<label>List Notifikasi Input</label>
									</div>
									<table class="table table-striped table-bordered gs-7">
										<thead>
											<tr>
												<th>Urutan</th>
												<th><input type="checkbox" value="<?= $value->id ?>" id="select-all3" name=""></th>
												<th>Nama</th>
												<th>Email</th>
												<th>No Telp</th>
											</tr>
										</thead>
										<tbody class="draggable-zone">
											<?php foreach ($data_admin as $key => $value): ?>
											<tr class="draggable">
												<td>
													<a href="#" class="btn btn-icon btn-sm btn-hover-light-primary draggable-handle">
														<!--begin::Svg Icon | path: icons/duotone/Text/Menu.svg-->
														<span class="svg-icon svg-icon-2x">
															<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
																<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
																	<rect x="0" y="0" width="24" height="24" />
																	<rect fill="#000000" x="4" y="5" width="16" height="3" rx="1.5" />
																	<path d="M5.5,15 L18.5,15 C19.3284271,15 20,15.6715729 20,16.5 C20,17.3284271 19.3284271,18 18.5,18 L5.5,18 C4.67157288,18 4,17.3284271 4,16.5 C4,15.6715729 4.67157288,15 5.5,15 Z M5.5,10 L18.5,10 C19.3284271,10 20,10.6715729 20,11.5 C20,12.3284271 19.3284271,13 18.5,13 L5.5,13 C4.67157288,13 4,12.3284271 4,11.5 C4,10.6715729 4.67157288,10 5.5,10 Z" fill="#000000" opacity="0.3" />
																</g>
															</svg>
														</span>
														<!--end::Svg Icon-->
													</a>
												</td>
												<td><input type="checkbox" value="<?= $value->id ?>" class="select3" name="notification_input[]"></td>
												<td><?= $value->fullname ?></td>
												<td><?= $value->email ?></td>
												<td><?= $value->phone ?></td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>


									<div class="form-group my-3 col-md-6">
										<label>List Notifikasi Output</label>
									</div>
									<table class="table table-striped table-bordered gs-7">
										<thead>
											<tr>
												<th>Urutan</th>
												<th><input type="checkbox" id="select-all4" name=""></th>
												<th>Nama</th>
												<th>Email</th>
												<th>No Telp</th>
											</tr>
										</thead>
										<tbody class="draggable-zone">
											<?php foreach ($data_admin as $key => $value): ?>
											<tr class="draggable">
												<td>
													<a href="#" class="btn btn-icon btn-sm btn-hover-light-primary draggable-handle">
														<!--begin::Svg Icon | path: icons/duotone/Text/Menu.svg-->
														<span class="svg-icon svg-icon-2x">
															<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
																<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
																	<rect x="0" y="0" width="24" height="24" />
																	<rect fill="#000000" x="4" y="5" width="16" height="3" rx="1.5" />
																	<path d="M5.5,15 L18.5,15 C19.3284271,15 20,15.6715729 20,16.5 C20,17.3284271 19.3284271,18 18.5,18 L5.5,18 C4.67157288,18 4,17.3284271 4,16.5 C4,15.6715729 4.67157288,15 5.5,15 Z M5.5,10 L18.5,10 C19.3284271,10 20,10.6715729 20,11.5 C20,12.3284271 19.3284271,13 18.5,13 L5.5,13 C4.67157288,13 4,12.3284271 4,11.5 C4,10.6715729 4.67157288,10 5.5,10 Z" fill="#000000" opacity="0.3" />
																</g>
															</svg>
														</span>
														<!--end::Svg Icon-->
													</a>
												</td>
												<td><input type="checkbox" value="<?= $value->id ?>" class="select4" name="notification_output[]"></td>
												<td><?= $value->fullname ?></td>
												<td><?= $value->email ?></td>
												<td><?= $value->phone ?></td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>

									<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
								</div>
								<!--end: Card Body-->
							</div>
						</form> 
					</div>
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->
<?= $this->endSection() ?>

<?= $this->section('js') ?>
<script src="<?= base_url(); ?>/plugins/custom/draggable/draggable.bundle.js"></script>
<script type="text/javascript">


var containers = document.querySelectorAll(".draggable-zone");

// if (containers.length === 0) {
//     return false;
// }

var swappable = new Sortable.default(containers, {
    draggable: ".draggable",
    handle: ".draggable .draggable-handle",
    mirror: {
        //appendTo: selector,
        appendTo: "body",
        constrainDimensions: true
    }
});


$('#select-all1').click(function(event) {
	if (this.checked) {
	  // Iterate each checkbox
	  $('.select1').each(function() {
	    this.checked = true;
	  });
	} else {
	  $('.select1').each(function() {
	    this.checked = false;
	  });
	}
});

$('#select-all2').click(function(event) {
	if (this.checked) {
	  // Iterate each checkbox
	  $('.select2').each(function() {
	    this.checked = true;
	  });
	} else {
	  $('.select2').each(function() {
	    this.checked = false;
	  });
	}
});

$('#select-all3').click(function(event) {
	if (this.checked) {
	  // Iterate each checkbox
	  $('.select3').each(function() {
	    this.checked = true;
	  });
	} else {
	  $('.select3').each(function() {
	    this.checked = false;
	  });
	}
});

$('#select-all4').click(function(event) {
	if (this.checked) {
	  // Iterate each checkbox
	  $('.select4').each(function() {
	    this.checked = true;
	  });
	} else {
	  $('.select4').each(function() {
	    this.checked = false;
	  });
	}
});

</script>
<?= $this->endSection() ?>