<?php namespace App\Models;

class AdminRoleModuleModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = "SELECT ".$param['select'];
        else        
            $query = 'SELECT 
                arm_id as "role_module_id", arm_insert_at as "insert_at",
                ar_id as "role_id", ar_name as "role_name", ar_slug as "role_slug", 
                am_id as "module_id", am_name as "module_name", am_slug as "module_slug",
                am_class as "class", am_method as "method", am_section as "section"
            ';

        $query .= " FROM admin_role_modules
            INNER JOIN admin_roles ON (ar_id=arm_role_id)
            INNER JOIN admin_modules ON (am_id=arm_module_id)
            WHERE 1 ";

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND arm_active=1 AND ar_active=1 AND am_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY arm_id ';


        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        
            

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['result_type'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($roleModuleID){
        $param = array(
            'where' => ' AND arm_active=1 AND ar_active=1 AND am_active=1 AND arm_id="'.$roleModuleID.'" ',
        );
        $result = $this->getAll($param);

        return $result;
    }

    public function getAllWithModule($param = []){
        $query = 'SELECT 
                arm_id as "role_module_id", arm_insert_at as "insert_at",
                ar_id as "role_id", ar_name as "role_name", ar_slug as "role_slug", 
                am_id as "module_id", am_name as "module_name", am_slug as "module_slug",
                am_class as "class", am_method as "method", am_section as "section", admins.admin_id, admins.admin_phone
            ';

        $query .= " FROM admin_role_modules
            INNER JOIN admin_roles ON (ar_id=arm_role_id)
            INNER JOIN admin_modules ON (am_id=arm_module_id)
            INNER JOIN admin_permissions ON admin_permissions.ap_role_id=admin_roles.ar_id
            INNER JOIN admins ON admins.admin_id=admin_permissions.ap_admin_id
            WHERE 1 ";

        if(isset($param['section'])){
            $query .= ' AND am_section="'.$param['section'].'" ';
        }

        if(isset($param['groupby'])){
            $query .= ' GROUP BY '.$param['groupby'];
        }

        return $this->db->query($query)->getResult();
    }

    public function getByRoleID($roleID){
        $param = array(
            'where' => ' AND arm_active=1 AND ar_active=1 AND am_active=1 AND arm_role_id="'.$roleID.'" ',
        );
        $result = $this->getAll($param);

        return $result;
    }  

    public function addAdminRoleModule($roleID, $moduleID, $insertAdminID ){

        $data = [
            'arm_role_id'           => $roleID,
            'arm_module_id'         => $moduleID,
            'arm_insert_admin_id'   => $insertAdminID,
            'arm_active'            => 1
        ];

        $adminRoleModules = $this->db->table('admin_role_modules');
        $adminRoleModules->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addAdminRoleModuleBulk($roleID, $moduleID, $insertAdminID ){
        $data = array();

        foreach ($moduleID as $key => $val) {
            $data[] = [
                'arm_role_id'           => $roleID,
                'arm_module_id'         => $val,
                'arm_insert_admin_id'   => $insertAdminID,
                'arm_active'            => 1
            ];
        }

        $adminRoleModules = $this->db->table('admin_role_modules');
        $adminRoleModules->insertBatch($data);

        return $roleID;
    }

    public function updateAdminRoleModuleBulk($roleID, $moduleID, $insertAdminID ){

        $data2 = [
             'arm_delete_at'       => getCurrentTime(),
            'arm_delete_admin_id' => $insertAdminID,
            'arm_active'          => 0
        ];
        $this->db->table('admin_role_modules')->where('arm_role_id',$roleID)->update($data2);

        $data = array();

        foreach ($moduleID as $key => $val) {
            $data[] = [
                'arm_role_id'           => $roleID,
                'arm_module_id'         => $val,
                'arm_insert_admin_id'   => $insertAdminID,
                'arm_active'            => 1
            ];
        }

        $adminRoleModules = $this->db->table('admin_role_modules');
        $adminRoleModules->insertBatch($data);

        return $roleID;
    }

    public function updateAdminRoleModule($adminRoleModuleID, $roleID, $moduleID, $updateAdminID ){
        $data = [
            'arm_role_id'           => $roleID,
            'arm_module_id'         => $moduleID,
            'arm_update_admin_id'   => $updateAdminID,
            'arm_active'            => 1
        ];
        $this->db->table('admin_role_modules')->where('arm_id',$adminRoleModuleID)->update($data);
        $param = array(
            'where' => ' AND arm_id="'.$adminRoleModuleID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];
        

        return $result;
        
    }

    public function deleteAdminRoleModule($adminRoleModuleID, $deleteAdminID ){
        $data = [
            'arm_delete_at'       => getCurrentTime(),
            'arm_delete_admin_id' => $deleteAdminID,
            'arm_active'          => 0
        ];

        $this->db->table('admin_role_modules')->where('arm_id',$adminRoleModuleID)->update($data);
        $param = array(
            'where' => ' AND arm_id="'.$adminRoleModuleID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}