<?php namespace App\Models;

class BatchItemOutputModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT bio_id as "id", bio_bi_id as "bi_id", bio_oi_id as "oi_id", bio_on_id as "on_id", bio_item_id as "item_id", bio_bit_id as "bit_id", bio_is_melt as "is_melt", bio_note as "note", bio_item_sku as "item_sku", bio_item_name as "item_name", bio_item_quantity as "item_quantity", bio_item_weight as "item_weight", bio_insert_at as "insert_at", bio_insert_admin_id as "insert_admin_id",bio_update_at as "update_at", bio_update_admin_id as "update_admin_id", bio_delete_at as "delete_at", bio_delete_admin_id as "delete_admin_id", bio_active as "active",  order_note, batch_code, batch_item_tasks.bit_group_note as "group_note", customer_name, workflow_name ';

        $query .= ' FROM batch_item_outputs 
            INNER JOIN batch_items ON batch_items.bi_id=batch_item_outputs.bio_bi_id 
            INNER JOIN order_items ON order_items.oi_id=batch_item_outputs.bio_oi_id 
            INNER JOIN batches ON batches.batch_id=batch_items.bi_batch_id
            INNER JOIN orders ON orders.order_id=order_items.oi_order_id 
            LEFT JOIN items ON items.item_id=batch_item_outputs.bio_item_id 
            LEFT JOIN batch_item_tasks ON batch_item_tasks.bit_id=batch_item_outputs.bio_bit_id
            LEFT JOIN customers ON orders.order_customer_id=customers.customer_id
            LEFT JOIN workflows ON workflows.workflow_id=items.item_workflow_id 
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND bio_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getAllReportProduksi($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT DATE(bio_insert_at) as "date", gc_code, gc_name, SUM(bio_item_quantity) as total_quantity, SUM(bio_item_weight) as total_weight, SUM(bio_item_quantity) as total_quantity ';

        $query .= ' FROM batch_item_outputs 
            JOIN items ON items.item_id=batch_item_outputs.bio_item_id 
            JOIN gold_contents ON gold_contents.gc_id=items.item_gc_id 
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND bio_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($bitID){
        $param = array(
            'where' => ' AND bio_id="'.$bitID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function setNote(){
        $query = "SELECT COALESCE(count(*),0) as 'total' FROM batch_item_outputs WHERE YEAR(bio_insert_at)='".date('Y')."' AND  MONTH(bio_insert_at)='".date('m')."' ";

        return $this->db->query($query)->getResult();
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND bio_active="1" AND bio_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function addBatchItemOutput($data){
        $bit = $this->db->table('batch_item_outputs');
        $bit->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addBatchItemOutputBulk($data){
        $bit = $this->db->table('batch_item_outputs');
        $result = $bit->insert($data);
        return $result;
    }

    public function updateBatchItemOutput($data, $bioID){

        $this->db->table('batch_item_outputs')->where('bio_id',$bioID)->update($data);
        $param = array(
            'where' => ' AND bio_id="'.$bioID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function deleteBatchItemOutput($bioID, $deleteAdminID ){
        $data = [
            'bio_delete_at'       => getCurrentTime(),
            'bio_delete_admin_id' => $deleteAdminID,
            'bio_active'          => 0
        ];

        $this->db->table('batch_item_outputs')->where('bio_id',$bioID)->update($data);
        $param = array(
            'where' => ' AND bio_id="'.$bioID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}