<?php namespace App\Models;

class BatchItemRequestModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT bir_id as "id", bir_bit_id as "bit_id", bir_bi_id as "bi_id", bir_item_sku as "item_sku", bir_item_name as "item_name", bir_item_quantity as "item_quantity", bir_item_weight as "item_weight", bir_item_source as "item_source", bir_status as "status", bir_insert_at as "insert_at", bir_insert_admin_id as "insert_admin_id",bir_update_at as "update_at", bir_update_admin_id as "update_admin_id", bir_delete_at as "delete_at", bir_delete_admin_id as "delete_admin_id", bir_active as "active", task_name, order_items.oi_id, order_items.oi_item_id ';

        $query .= ' FROM batch_item_requests 
            LEFT JOIN batch_items ON batch_items.bi_id=batch_item_requests.bir_bi_id
            LEFT JOIN order_items ON order_items.oi_id=batch_items.bi_oi_id 
            LEFT JOIN batch_item_tasks ON batch_item_tasks.bit_id=batch_item_requests.bir_bit_id 
            LEFT JOIN tasks ON tasks.task_id=batch_item_tasks.bit_task_id
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND bir_active=1 ';

        if(@$param['groupby'] == '-')
            $query .= ' ';
        else if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY bir_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($bitID){
        $param = array(
            'where' => ' AND bir_id="'.$bitID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND bir_active="1" AND bir_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function addBatchItemRequest($data){
        $bit = $this->db->table('batch_item_requests');
        $bit->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addBatchItemRequestBulk($data){
        $bit = $this->db->table('batch_item_requests');
        $result = $bit->insertBatch($data);
        return $result;
    }

    public function updateBatchItemRequest($data, $bitID){

        $this->db->table('batch_item_requests')->where('bir_id',$bitID)->update($data);
        $param = array(
            'where' => ' AND bir_id="'.$bitID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

     public function updateBatchItemRequestByBatchBulk($data, $biIDArray){

        $this->db->table('batch_item_requests')->whereIn('bir_bi_id',$biIDArray)->update($data);
        $biIDData = implode(',', $biIDArray);
        $param = array(
            'where' => ' AND bir_bi_id IN ("'.$biIDData.'") ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function deleteBatchItemRequest($birID, $deleteAdminID ){
        $data = [
            'bir_delete_at'       => getCurrentTime(),
            'bir_delete_admin_id' => $deleteAdminID,
            'bir_active'          => 0
        ];

        $this->db->table('batch_item_requests')->where('bir_id',$birID)->update($data);
        $param = array(
            'where' => ' AND bir_id="'.$birID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}