<?php namespace App\Models;

class BatchItemTaskModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT bit_id as "id", bit_order as "order", bit_order as "order", bit_bi_id as "bi_id", bit_workflow_id as "workflow_id", batch_items.bi_erp_barcode as "erp_barcode", bit_task_id as "task_id", bit_group_note as "group_note", bit_is_repaired as "is_repaired", bit_repaired_bit_id as "repaired_bit_id", bit_input_operator_name as "input_operator_name", bit_output_operator_name as "output_operator_name", bit_input_fields as "input_fields", bit_output_fields as "output_fields", bit_input_quantity as "input_quantity", bit_output_quantity as "output_quantity", bit_input_weight as "input_weight", bit_output_weight as "output_weight", bit_status_field as "status_field", bit_status as "status", bit_insert_at as "insert_at", bit_insert_admin_id as "insert_admin_id", admin_fullname as "insert_admin_name", bit_update_at as "update_at", bit_update_admin_id as "update_admin_id", gold_contents.gc_name as "gold_content", items.item_sku as "item_sku", items.item_id, items.item_name as "item_name", order_items.oi_quantity as "quantity", order_items.oi_completed_quantity as "completed_quantity", task_name, workflow_name, batch_items.bi_batch_id as "batch_id", batch_code, SUM(batch_item_requests.bir_item_weight) as "sum_bir_item_quantity", batch_items.bi_oi_id as "oi_id", order_note, SUM(item_materials.im_quantity) as "sum_item_material", order_id, batch_item_tasks.bit_start_at as "start_at", batch_item_tasks.bit_end_at as "end_at", customer_name,  order_start_due_date as "start_due_date", order_request_total as "request_total", order_request_description as "request_description"  ';

        $query .= ' FROM batch_item_tasks 
                LEFT JOIN admins ON admin_id=bit_update_admin_id
                INNER JOIN batch_items ON batch_items.bi_id=batch_item_tasks.bit_bi_id 
                INNER JOIN batches ON batches.batch_id=batch_items.bi_batch_id 
                INNER JOIN  gold_contents ON gold_contents.gc_id=batches.batch_gc_id 
                INNER JOIN order_items ON order_items.oi_id=batch_items.bi_oi_id 
                INNER JOIN orders ON orders.order_id=order_items.oi_order_id 
                LEFT JOIN customers ON orders.order_customer_id=customers.customer_id
                INNER JOIN items ON items.item_id=order_items.oi_item_id 
                INNER JOIN tasks ON tasks.task_id=batch_item_tasks.bit_task_id
                INNER JOIN workflows ON workflows.workflow_id=batch_item_tasks.bit_workflow_id 
                LEFT JOIN batch_item_requests ON batch_item_requests.bir_bit_id=batch_item_tasks.bit_id 
                LEFT JOIN item_materials ON item_materials.im_item_id=items.item_id
                WHERE 1 
                AND batch_items.bi_active=1
                ';   

        if(!empty($param['where']))
            $query .= ' '.$param['where'];

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY bit_id ';

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY bit_group_note, bit_insert_at ASC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';


        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }


    public function getAllTracking($param=array()){

        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT bit_1.bit_id as "id", bit_1.bit_order as "order", bit_1.bit_bi_id as "bi_id", bit_1.bit_workflow_id as "workflow_id", batch_items.bi_erp_barcode as "erp_barcode", bit_1.bit_task_id as "task_id", bit_1.bit_group_note as "group_note", bit_1.bit_is_repaired as "is_repaired", bit_1.bit_repaired_bit_id as "repaired_bit_id", bit_1.bit_input_operator_name as "input_operator_name", bit_1.bit_output_operator_name as "output_operator_name", bit_1.bit_input_fields as "input_fields", bit_1.bit_output_fields as "output_fields", bit_1.bit_input_quantity as "input_quantity", bit_1.bit_output_quantity as "output_quantity", bit_1.bit_input_weight as "input_weight", bit_1.bit_output_weight as "output_weight", bit_1.bit_status_field as "status_field", bit_1.bit_status as "status", bit_1.bit_insert_at as "insert_at", bit_1.bit_insert_admin_id as "insert_admin_id", bit_1.bit_update_at as "update_at", bit_1.bit_update_admin_id as "update_admin_id", items.item_sku as "item_sku", items.item_id, items.item_name as "item_name", order_items.oi_quantity as "quantity", order_items.oi_completed_quantity as "completed_quantity", task_name, workflow_name, batch_items.bi_batch_id as "batch_id", batch_code, order_id,order_note, bit_2.bit_group_note as "group_note_2", bit_1.bit_start_at as "start_at", bit_1.bit_end_at as "end_at" ';


        $query .= ' FROM batch_item_tasks bit_1
                INNER JOIN batch_items ON batch_items.bi_id=bit_1.bit_bi_id 
                INNER JOIN batches ON batches.batch_id=batch_items.bi_batch_id 
                INNER JOIN order_items ON order_items.oi_id=batch_items.bi_oi_id 
                INNER JOIN orders ON orders.order_id=order_items.oi_order_id 
                INNER JOIN items ON items.item_id=order_items.oi_item_id 
                INNER JOIN tasks ON tasks.task_id=bit_1.bit_task_id
                INNER JOIN workflows ON workflows.workflow_id=bit_1.bit_workflow_id 
                LEFT JOIN batch_item_tasks bit_2 ON bit_2.bit_id=bit_1.bit_repaired_bit_id 
                WHERE 1 
                AND batch_items.bi_active=1
                ';   

        if(!empty($param['where']))
            $query .= ' '.$param['where'];

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY bit_1.bit_id ';

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY bit_1.bit_group_note, bit_1.bit_insert_at ASC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();

    }

    public function getAllGroupNote($param=array()){

        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT bit_1.bit_id as "id", bit_1.bit_order as "order", bit_1.bit_bi_id as "bi_id", bit_1.bit_workflow_id as "workflow_id", batch_items.bi_erp_barcode as "erp_barcode", bit_1.bit_task_id as "task_id", bit_1.bit_group_note as "group_note", bit_1.bit_is_repaired as "is_repaired", bit_1.bit_repaired_bit_id as "repaired_bit_id", bit_1.bit_input_operator_name as "input_operator_name", bit_1.bit_output_operator_name as "output_operator_name", bit_1.bit_input_fields as "input_fields", bit_1.bit_output_fields as "output_fields", bit_1.bit_input_quantity as "input_quantity", bit_1.bit_output_quantity as "output_quantity", bit_1.bit_input_weight as "input_weight", bit_1.bit_output_weight as "output_weight", bit_1.bit_status_field as "status_field", bit_1.bit_status as "status", bit_1.bit_insert_at as "insert_at", bit_1.bit_insert_admin_id as "insert_admin_id", bit_1.bit_update_at as "update_at", bit_1.bit_update_admin_id as "update_admin_id", items.item_sku as "item_sku", items.item_id, items.item_name as "item_name", order_items.oi_quantity as "quantity", order_items.oi_completed_quantity as "completed_quantity", task_name, workflow_name, batch_items.bi_batch_id as "batch_id", batch_code, order_id,order_note, bit_2.bit_group_note as "group_note_2", bit_1.bit_start_at as "start_at", bit_1.bit_end_at as "end_at",  order_start_due_date as "start_due_date", order_request_total as "request_total", order_request_description as "request_description", tree_name ';


        $query .= ' FROM batch_item_tasks bit_1
                INNER JOIN batch_items ON batch_items.bi_id=bit_1.bit_bi_id 
                INNER JOIN batches ON batches.batch_id=batch_items.bi_batch_id 
                INNER JOIN order_items ON order_items.oi_id=batch_items.bi_oi_id 
                INNER JOIN orders ON orders.order_id=order_items.oi_order_id 
                INNER JOIN items ON items.item_id=order_items.oi_item_id 
                INNER JOIN tasks ON tasks.task_id=bit_1.bit_task_id
                INNER JOIN trees ON trees.tree_id=batches.batch_tree_id
                INNER JOIN workflows ON workflows.workflow_id=bit_1.bit_workflow_id 
                LEFT JOIN batch_item_tasks bit_3 ON bit_3.bit_group_note=bit_1.bit_group_note AND bit_3.bit_status="Completed"  
                LEFT JOIN batch_item_tasks bit_2 ON bit_2.bit_id=bit_3.bit_repaired_bit_id 
                WHERE 1 
                AND bit_1.bit_status IN ("Proses", "New")
                AND batch_items.bi_active=1
                ';   

        if(!empty($param['where']))
            $query .= ' '.$param['where'];

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY bit_1.bit_group_note ';

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY bit_1.bit_insert_at ASC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();

    }


    public function getByID($bitID){
        $bit = $this->db->table('batch_item_tasks');
        $bit->select('bit_id as "id", bit_code as "code", bit_name as "name", bit_insert_at as "insert_at" ');
        $bit->where('bit_id', $bitID);
        $bit->where('bit_active', 1);

        $result = $bit->get()->getRow();

        return $result;
    }


    public function setNote(){
        $query = "SELECT COALESCE(count(*),0) as 'total' FROM batch_item_tasks WHERE YEAR(bit_insert_at)='".date('Y')."' AND  MONTH(bit_insert_at)='".date('m')."' GROUP BY bit_group_note ";

        $data = $this->db->query($query)->getResult();

        return count($data);
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND bit_active="1" AND bit_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function addBatchItemTask($data){
        $bit = $this->db->table('batch_item_tasks');
        $bit->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addBatchItemTaskBulk($data){
        $bit = $this->db->table('batch_item_tasks');
        $result = $bit->insertBatch($data);
        return $result;
    }

    public function updateBatchItemTask($data, $bitID){

        $this->db->table('batch_item_tasks')->where('bit_id',$bitID)->update($data);
        $param = array(
            'where' => ' AND bit_id="'.$bitID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function deleteBatchItemTask($bitID, $deleteAdminID ){
        $data = [
            'bit_delete_at'       => getCurrentTime(),
            'bit_delete_admin_id' => $deleteAdminID,
            'bit_active'          => 0
        ];

        $this->db->table('batch_item_tasks')->where('bit_id',$bitID)->update($data);
        $param = array(
            'where' => ' AND bit_id="'.$bitID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteBatchItemTaskByBatch($batchID, $deleteAdminID ){
        $data = [
            'bit_delete_at'       => getCurrentTime(),
            'bit_delete_admin_id' => $deleteAdminID,
            'bit_active'          => 0
        ];

        $batchItemData = $this->db->table('batch_items')->select('bi_id as "id" ')->where('bi_batch_id',$batchID)->get()->getResult();
        $batchItemArray = [];
        foreach ($batchItemData as $key => $value) {
            $batchItemArray[] = $value->id;
        }

        $result = true;

        if (!empty($batchItemArray)) {
            $this->db->table('batch_item_tasks')->whereIn('bit_bi_id',$batchItemArray)->update($data);
            
            $param = array(
                'where' => ' AND bit_bi_id IN ("'.implode(',', $batchItemArray).'") ',
            );
            $result = $this->getAll($param);
            if ($result)
                $result = $result[0];
        }


        return $result;
        
    }

}