<?php namespace App\Models;

class OperatorModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT operator_id as "id", operator_name as "name", operator_insert_at as "insert_at", operator_insert_admin_id as "insert_admin_id", operator_update_at as "update_at", operator_update_admin_id as "update_admin_id", operator_delete_at as "delete_at", operator_delete_admin_id as "delete_admin_id", operator_active as "active" ';

        $query .= ' FROM operators WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND operator_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY operator_id ';

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

     public function getByNota($nota){
        $param = array(
            'where' => ' AND operator_active="1" AND operator_note="'.$nota.'" ',
        );
        $result = $this->getAll($param);
        return $result;
    }

    public function getByID($operatorID){
        $param['where'] = ' AND operator_id='.$operatorID.' AND operator_active=1 ';
        $result = $this->getAll($param);
        return $result[0];
    }

    public function addOperator($data){
        $operator = $this->db->table('operators');
        $operator->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addOperatorBulk($data){
        $operator = $this->db->table('operators');
        $operator->insertBatch($data);

        return $data;
    }

    public function updateOperator($data, $operatorID){

        $this->db->table('operators')->where('operator_id',$operatorID)->update($data);
        $param = array(
            'where' => ' AND operator_id="'.$operatorID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteOperator($operatorID, $deleteAdminID ){
        $data = [
            'operator_delete_at'       => getCurrentTime(),
            'operator_delete_admin_id' => $deleteAdminID,
            'operator_active'          => 0,
        ];

        $this->db->table('operators')->where('operator_id',$operatorID)->update($data);
        $param = array(
            'where' => ' AND operator_id="'.$operatorID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }



}