<?php namespace App\Models;

class OperatorTaskModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT ot_id as "id", ot_task_id as "task_id", ot_operator_id as "operator_id", ot_insert_at as "insert_at", ot_insert_admin_id as "insert_admin_id", ot_delete_at as "delete_at", ot_delete_admin_id as "delete_admin_id", ot_active as "active", task_name, operator_id, operator_name';

        $query .= ' FROM operator_tasks  
        JOIN tasks ON tasks.task_id=operator_tasks.ot_task_id AND task_active=1
        JOIN operators ON operators.operator_id=operator_tasks.ot_operator_id  AND operator_active=1 
        WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND ot_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];
        else
            $query .= ' GROUP BY ot_id ';

        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

     public function getByNota($nota){
        $param = array(
            'where' => ' AND ot_active="1" AND ot_note="'.$nota.'" ',
        );
        $result = $this->getAll($param);
        return $result;
    }

    public function getByID($otID){
        $param['where'] = ' AND ot_id='.$otID.' AND ot_active=1 ';
        $result = $this->getAll($param);
        return $result[0];
    }

    public function addOperatorTask($data){
        $operator = $this->db->table('operator_tasks');
        $operator->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addOperatorTaskBulk($data){
        $operator = $this->db->table('operator_tasks');
        $operator->insertBatch($data);

        return $data;
    }

    public function getOperatorTaskGetByOperator($operatorID){
        $param['where'] = ' AND ot_operator_id='.$operatorID.' AND ot_active=1 ';
        $result = $this->getAll($param);
        return $result;
    }

    public function updateOperatorTask($data, $otID){

        $this->db->table('operator_tasks')->where('ot_id',$otID)->update($data);
        $param = array(
            'where' => ' AND ot_id="'.$otID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteOperatorTaskByOperator($operatorID, $deleteAdminID){

        $data = [
            'ot_delete_at'       => getCurrentTime(),
            'ot_delete_admin_id' => $deleteAdminID,
            'ot_active'          => 0,
        ];

        $result = $this->db->table('operator_tasks')->where('ot_operator_id',$operatorID)->update($data);
        return $result;

    }

    public function deleteOperatorTask($otID, $deleteAdminID ){
        $data = [
            'ot_delete_at'       => getCurrentTime(),
            'ot_delete_admin_id' => $deleteAdminID,
            'ot_active'          => 0,
        ];

        $this->db->table('operator_tasks')->where('ot_id',$otID)->update($data);
        $param = array(
            'where' => ' AND ot_id="'.$otID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }



}