 <?php

namespace App\Controllers;

class AdminModule extends BaseController
{
	public function index($id)
	{
		$query = [
			'session_admin_token' => $this->session->get('session_admin_token'),
			'role_id' => $id,
		];

		$result = json_decode(sendRequest($this->api['endpoint'].'/admin/role/module/get/role', 'POST', $this->api['headers'], $query));

		if (@$result->status == 403) {
			return redirect('dashboard');
		}

		$data = [
			'data' => (@$result->status == 200 )? $result->data : [],
			'title' => lang('Menu.user.admin.main'),
			'menu' => 'admin',
		];

		return view('admin-module/index', $data);
	}

	public function store($admin_id)
	{
		if (!$this->request->isAjax()) {
			return false;
		}

		$data = [
			'session_admin_token' => $this->session->get('session_admin_token'),
			'role_id' => $this->request->getPost('module_id'),
			'module_id' => $this->request->getPost('module_id'),
		];

		$result = json_decode(sendRequest($this->api['endpoint'].'/admin/role/module/add', 'POST', $this->api['headers'], $data));

		$data = [
			'session_admin_token' => $this->session->get('session_admin_token'),
			'admin_id' => $admin_id,
			'role_id' => $this->request->getPost('role_id'),
		];

		$result = json_decode(sendRequest($this->api['endpoint'].'/admin/module/update', 'POST', $this->api['headers'], $data));

		$result = json_decode(sendRequest($this->api['endpoint'].'/admin/module/add', 'POST', $this->api['headers'], $data));

		return result_message_json($result, 'add');
	}

	public function update($id)
	{
		if (!$this->request->isAjax()) {
			return false;
		}

		$data = [
			'session_admin_token' => $this->session->get('session_admin_token'),
			'role_id' => $this->session->get('role'),
			'module_id' => $id,
			'admin_role_module_id' => $this->session->get('admin_role_module_id')
		];

		$result = json_decode(sendRequest($this->api['endpoint'].'/admin/role/module/update', 'POST', $this->api['headers'], $data));

		return result_message_json($result, 'edit', 'admin/role');
	}
}
