<?php
namespace App\Controllers;

use App\Models\ItemModel;
use App\Models\OrderModel;
use App\Models\OrderItemModel;
use App\Models\WorkflowModel;
use App\Models\TaskModel;
use App\Models\BatchModel;
use App\Models\BatchItemModel;
use Ramsey\Uuid\Uuid;
use App\Libraries\S3Library;
use App\Models\AdminRoleModuleModel;
use App\Models\TreeModel;
use App\Models\PrintHistoryModel;
use App\Models\BatchItemTaskModel;
use App\Models\BatchItemRequestModel;

class BatchItemRequest extends BaseController
{

	public function data($biID){
		// if (!$this->request->isAjax()) {
		// 	return false;
		// }

		// if ($this->request->getVar('param_type') == 'searchItem') {
		// 	return $this->searchItem();
		// }

		$batchItemRequestModel = new BatchItemRequestModel();
		$batchItemRequestData = $batchItemRequestModel->getAll(['where' => ' AND bir_bi_id="'.$biID.'" AND bir_active=1 ', 'orderby' => ' bir_id ASC ']);
		$data = [];

		if (@$batchItemRequestData) {
        	foreach ($batchItemRequestData as $index => $val ) {

	            $btn_delete = '&nbsp;<a href="javascript:;" class="btn btn-icon btn-danger" onclick="return deleteData(`'.base_url().'/batch-item-request/delete/'.$val->id.'`)" '.lang('Action.tooltip.delete').'>'.lang('Action.icon.lg.delete').'</a>';

				$btn_edit = '&nbsp;<a href="javascript::void(0)" data-bs-toggle="modal" data-bs-target="#kt_modal_2" onclick="batchItemRequest(`'.$val->id.'`, `'.$val->bi_id.'`, `'.$val->bit_id.'`, `'.$val->item_source.'`, `'.$val->item_sku.'`, `'.$val->item_name.'`, `'.$val->item_quantity.'`, `'.$val->item_weight.'`)" class="btn btn-success btn-icon" '.lang('Action.tooltip.edit').'>'.lang('Action.icon.lg.edit').'</a>';

	            $value['no'] = $index+1;
	            $value['item_sku'] = $val->item_sku;
	            $value['item_source'] = $val->item_source;
	            $value['task_name'] = $val->task_name;
	            $value['item_name'] = $val->item_name;
	            $value['item_quantity'] = $val->item_quantity;
	            $value['item_weight'] = $val->item_weight;
	            $value['status'] = $val->status;
	            $value['input_item_weight'] = '<input type="number" step="any" class="form-control form-control-sm item_weight trigger sum-quantity" value="'.$val->item_weight.'" name="item_weight[]" data-id="'.$val->id.'" data-bi_id="'.$val->bi_id.'">';
	            $value['status'] = $val->status;

				$value['action'] = $btn_edit.$btn_delete;
            	array_push($data,$value);
        	}
    	}

        $search = $this->request->getVar('search');

        if (isset($search['value']) && $search['value']) {
            $data = $this->arraySearch($data, $search['value']);
        }

        $totalRecords = $totalDisplay = count($data);

        $order = $this->request->getVar('order');

        if (isset($order[0]['column']) && $order[0]['dir']) {
            $column = $order[0]['column'];
            $dir    = $order[0]['dir'];
            usort($data, function ($a, $b) use ($column, $dir) {
                $a = array_slice($a, $column, 1);
                $b = array_slice($b, $column, 1);
                $a = array_pop($a);
                $b = array_pop($b);

                if ($dir === 'asc') {
                    return $a > $b ? 1 : -1;
                }

                return $a < $b ? 1 : -1;
            });
        }

        // pagination length
        if ($this->request->getVar('length')) {
            $data = array_splice($data, $this->request->getVar('start'), $this->request->getVar('length'));
        }

        $result = [
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $totalDisplay,
            'data'            => $data,
        ];

        echo json_encode($result, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);
	}

	public function store(){
		// bir_id bir_bi_id bir_bit_id	bir_item_sku bir_item_name bir_item_quantity	bir_item_weight

		$rules = [
            'bi_id' => ['label' => 'Batch Item', 'rules' => 'required|max_length[11]'],
            'item_name' => ['label' => 'Nama', 'rules' => 'required|max_length[255]'],
            'item_quantity' => ['label' => 'Jumlah', 'rules' => 'required|max_length[11]'],
            'item_weight' => ['label' => 'Weight', 'rules' => 'max_length[65]'],
        ];

        $groupNote = $this->request->getVar('group_note');

		$data = [
			'bir_bi_id' => $this->request->getPost('bi_id', FILTER_SANITIZE_STRING),
			'bir_bit_id' => $this->request->getPost('bit_id', FILTER_SANITIZE_STRING),
			'bir_item_source' => $this->request->getPost('item_source', FILTER_SANITIZE_STRING),
			'bir_item_sku' => $this->request->getPost('item_sku', FILTER_SANITIZE_STRING),
			'bir_item_name' => $this->request->getPost('item_name', FILTER_SANITIZE_STRING),
			'bir_item_quantity' => $this->request->getPost('item_quantity', FILTER_SANITIZE_STRING),
			'bir_item_weight' => $this->request->getPost('item_weight', FILTER_SANITIZE_STRING),
			'bir_insert_at' => getCurrentTime(),
			'bir_insert_admin_id' => $this->session->get('id'),
			'bir_status' => 'New',
			'bir_active' => 1
		];

		$this->api['headers'] = [
			'Accept'        => 'application/json',
			'Authorization: Bearer '.getenv('PRODUCTION_BEARER_TOKEN')
		];

		$itemQuantity = $this->request->getVar('item_quantity', FILTER_SANITIZE_STRING);

		$resultItemData = [];

		if ($this->request->getVar('item_source') == "Gudang Batu") {
			$rules['item_sku'] = ['label' => 'SKU', 'rules' => 'required|max_length[255]'];

			// $body = [
			// 	"keyword" => $this->request->getVar('item_sku', FILTER_SANITIZE_STRING),
			// ];

			// if ($body["keyword"] != '') {

			// 	$resultItem = json_decode(sendRequest(getenv('PRODUCTION_SEARCH_ITEM_URL'), 'POST', $this->api['headers'], $body));

			// 	if (empty($resultItem->data)) {
			// 		$data = [
			// 			'error'=> 'SKU Tidak ditemukan',
			// 		];

			// 		return json_encode($data);
			// 	}else{

			// 		$resultItemData = $resultItem->data[0];

			// 		if ($itemQuantity != '') {
						
			// 			if ($itemQuantity > $resultItemData->item_quantity) {
			// 				$data = [
			// 					'data' => $resultItemData,
			// 					'error'=> 'Jumlah Tidak tersedia',
			// 				];

			// 				return json_encode($data);
			// 			}
			// 		}

			// 		$resultItemData->item_quantity = $itemQuantity;
			// 	}
			// }

			$dataStone = [];
			$dataStone["material_bulk[".$data['bir_item_sku']."]"] = $data['bir_item_quantity'];
			if (!empty($dataStone)) {
				$dataStone["user_id"] = 1;
				$dataStone["description"] = $groupNote;
			}

			if (!empty($dataStone)) {
				$api['headers'] = [
					'Accept'        => 'application/json',
					'Authorization: Bearer '.GUDANG_BATU_TOKEN
				];

				$resultMaterialOut = json_decode(sendRequest(GUDANG_BATU_URL_VALIDATE, 'POST', $api['headers'], $dataStone ));

				if ($resultMaterialOut->status != 200) {
					$data = [
						'error'=> errorMessage($resultMaterialOut->data->error_message),
					];

					return json_encode($data);
				}
			}
		}


		if (!$this->validate($rules)) {
			$msg = [
                'error' => $this->validation->listErrors(),
            ];
            return json_encode($msg);
		}

		$batchItemRequestModel = new BatchItemRequestModel();
		$result = $batchItemRequestModel->addBatchItemRequest($data);

		if ($this->request->getVar('item_source') == "Gudang Batu") {
			$dataStone = [];
			$dataStone["material_bulk[".$data['bir_item_sku']."]"] = $data['bir_item_quantity'];
			if (!empty($dataStone)) {
				$dataStone["user_id"] = 1;
				$dataStone["description"] = $groupNote.'-'.$result;
			}

			if (!empty($dataStone)) {
				$api['headers'] = [
					'Accept'        => 'application/json',
					'Authorization: Bearer '.GUDANG_BATU_TOKEN
				];

				$resultMaterialOut = json_decode(sendRequest(GUDANG_BATU_URL_CREATE, 'POST', $api['headers'], $dataStone ));

				if ($resultMaterialOut->status != 200) {
					$data = [
						'error'=> lang('Validation.error_add'),
					];

					return json_encode($data);
				}
			}
		}

		if ($result) {
			$data = [
				'success'=> lang('Validation.success_add'),
				'modal_close' => '#kt_modal_1',
			];

			return json_encode($data);
		}
	}

	public function update($id){

		$paramType = $this->request->getVar('param_type');

		if ($paramType == 'updateWeight') {
			return $this->updateWeight($id);
		}else if($paramType == 'checkApprove'){
			return $this->checkApprove($id);
		}

		$rules = [
            // 'item_sku' => ['label' => 'SKU', 'rules' => 'required|max_length[255]'],
            // 'item_name' => ['label' => 'Nama', 'rules' => 'required|max_length[255]'],
            // 'item_quantity' => ['label' => 'Jumlah', 'rules' => 'required|max_length[11]'],
            'item_weight' => ['label' => 'Weight', 'rules' => 'required|max_length[65]'],
        ];


        // if ($this->request->getVar('item_source') == "Gudang Batu") {

		// 	$body = [
		// 		"keyword" => $this->request->getVar('item_sku', FILTER_SANITIZE_STRING),
		// 	];

		// 	if ($body["keyword"] != '') {

		// 		$resultItem = json_decode(sendRequest(getenv('PRODUCTION_SEARCH_ITEM_URL'), 'POST', $this->api['headers'], $body));

		// 		if (empty($resultItem->data)) {
		// 			$data = [
		// 				'error'=> 'SKU Tidak ditemukan',
		// 			];

		// 			return json_encode($data);
		// 		}else{

		// 			$resultItemData = $resultItem->data[0];

		// 			if ($itemQuantity != '') {
						
		// 				if ($itemQuantity > $resultItemData->item_quantity) {
		// 					$data = [
		// 						'data' => $resultItemData,
		// 						'error'=> 'Jumlah Tidak tersedia',
		// 					];

		// 					return json_encode($data);
		// 				}
		// 			}

		// 			$resultItemData->item_quantity = $itemQuantity;
		// 		}	
		// 	}
		// }


		if (!$this->validate($rules)) {
			$msg = [
                'error' => $this->validation->listErrors(),
            ];
            return json_encode($msg);
		}

		$data = [
			// 'bir_item_sku' => $this->request->getPost('item_sku', FILTER_SANITIZE_STRING),
			// 'bir_item_name' => $this->request->getPost('item_name', FILTER_SANITIZE_STRING),
			// 'bir_item_quantity' => $this->request->getPost('item_quantity', FILTER_SANITIZE_STRING),
			'bir_item_weight' => $this->request->getPost('item_weight', FILTER_SANITIZE_STRING),
			'bir_update_at' => getCurrentTime(),
			'bir_update_admin_id' => $this->session->get('id'),
			'bir_active' => 1
		];

		$batchItemRequestModel = new BatchItemRequestModel();

		$batchItemRequestData = $batchItemRequestModel->getByID($id);

		if($batchItemRequestData->status == 'New'){
			$msg = [
                'error' => lang('ErrorMessages.materialNotYetApproved'),
            ];
            return json_encode($msg);
		}

		$result = $batchItemRequestModel->updateBatchItemRequest($data, $id);

		if ($result) {
			$data = [
				'success'=> lang('Validation.success_edit'),
				'modal_close' => '#kt_modal_2',
			];

			return json_encode($data);
		}
	}


	public function updateWeight($id){
		$rules = [
            'bi_id' => ['label' => 'Batch Item', 'rules' => 'required'],
            'item_weight' => ['label' => 'Weight', 'rules' => 'required'],
        ];

		if (!$this->validate($rules)) {
			$msg = [
                'error' => $this->validation->listErrors(),
            ];
            return json_encode($msg);
		}

		$batchItemRequestModel = new BatchItemRequestModel();
		$itemWeight = $this->request->getPost('item_weight');
		$biID = $this->request->getPost('bi_id');
		$weight = $this->request->getPost('weight');
		$totalWeight = array_sum($itemWeight);

		$data = [
			'bir_item_weight' => $weight,
			'bir_update_at' => getCurrentTime(),
			'bir_update_admin_id' => $this->session->get('id'),
			'bir_active' => 1
		];

		$result = $batchItemRequestModel->updateBatchItemRequest($data, $id);

		$batchItemModel = new BatchItemModel();

		$data = [
			'bi_stone_weight' => $totalWeight,
			'bi_update_at' => getCurrentTime(),
			'bi_update_admin_id' => $this->session->get('id'),
			'bi_active' => 1
		];

		$result2 = $batchItemModel->updateBatchItem($data, $biID);

		if ($result) {
			$data = [
				'data'=> $totalWeight,
			];

			return json_encode($data);
		}
	}

	public function checkApprove($id){
		$batchID = $this->request->getVar('batch', FILTER_SANITIZE_STRING);
		$batchItemModel = new BatchItemModel();
		$batchItemRequestModel = new BatchItemRequestModel();
		$batchItemData = $batchItemModel->getByBatchID($batchID);

		foreach ($batchItemData as $key => $value) {

			$batchItemRequestGet = $batchItemRequestModel->getAll(['where' => 'AND bir_status="New" AND bir_bi_id="'.$value->id.'" AND bir_active=1 ']);

			if(count($batchItemRequestGet) > 0){
				$msg = [
					'status' => false,
	                'error' => 'Request batu belum disetujui',
	            ];
	            return json_encode($msg);
			}
		}

		return json_encode(['status' => true]);
	}

	public function print($biID){
		$batchItemRequestModel = new BatchItemRequestModel();
		$batchItemRequestData = $batchItemRequestModel->getAll(['where' => ' AND bir_bi_id="'.$biID.'" AND bir_active=1 ', 'orderby' => ' bir_id ASC ']);

		$batchItemTaskModel = new BatchItemTaskModel();
		$batchItemTaskData = $batchItemTaskModel->getAll(['where' => ' AND bit_bi_id="'.$biID.'" ', 'orderby' => ' bit_id ASC ']);

		$data = [
			'title'=> lang('Menu.order.batch-item-task.main'),
			'menu'=> 'batch-item-task',
			'data'=> $batchItemRequestData,
			'dataTask' => $batchItemTaskData,
			'biID' => $biID
		];
		
		return view('batch-item-task/print-request', $data);
	}

	public function delete($id)
	{
		$batchItemRequestModel = new BatchItemRequestModel();
		$batchItemRequest = $batchItemRequestModel->deleteBatchItemRequest($id, $this->session->get('id')); 

		if ($batchItemRequest) {
			$data = [
				'success'=> lang('Validation.success_delete'),
			];

			return json_encode($data);
		}
	}

	public function searchItem(){

		$this->api['headers'] = [
			'Accept'        => 'application/json',
			'Authorization: Bearer '.getenv('PRODUCTION_BEARER_TOKEN')
		];

		$itemQuantity = $this->request->getVar('item_quantity', FILTER_SANITIZE_STRING);

		$resultItemData = [];

		if ($this->request->getVar('item_source') == 'Gudang Batu') {

			$body = [
				"keyword" => $this->request->getVar('item_sku', FILTER_SANITIZE_STRING),
			];

			if ($body["keyword"] != '') {

				$resultItem = json_decode(sendRequest(getenv('PRODUCTION_SEARCH_ITEM_URL'), 'POST', $this->api['headers'], $body));

				if (empty($resultItem->data)) {
					$data = [
						'error'=> 'SKU Tidak ditemukan',
					];

					return json_encode($data);
				}else{

					$resultItemData = $resultItem->data[0];

					if ($itemQuantity != '') {
						
						if ($itemQuantity > $resultItemData->item_quantity) {
							$data = [
								'data' => $resultItemData,
								'error'=> 'Jumlah Tidak tersedia',
							];

							return json_encode($data);
						}
					}

					$resultItemData->item_quantity = $itemQuantity;
				}	
			}
		}

		return json_encode([
			'data' => $resultItemData,
		]);
	}

	
}