<?php
namespace App\Controllers;

use App\Models\OrderModel;
use App\Models\OrderItemModel;
use App\Models\BatchItemRequestModel;
use App\Models\BatchModel;
use App\Models\BatchItemModel;

class Worker extends BaseController {
	
	public function notificationWhatsApp(){

		$orderModel = new OrderModel();
		$orderDataTodayDueDate = $orderModel->getAll([
			'where'=> ' AND order_status IN ("Proses", "New") AND order_due_date="'.date('Y-m-d').'" AND order_active=1',
			'orderby'=> 'orders.order_due_date'
		]);

		$htmlTodayDueDate = 'ORDER JATUH TEMPO
';
		foreach ($orderDataTodayDueDate as $key => $value) {
			$htmlTodayDueDate .= $value->note .' ('.getTanggal($value->due_date).')
';
		}

		$tomorrow = date("Y-m-d", strtotime("+1 day"));
		$orderDataHmin1Date = $orderModel->getAll([
			'where'=> ' AND order_status IN ("Proses", "New") AND order_due_date="'.$tomorrow.'" AND order_active=1',
			'orderby'=> 'orders.order_due_date'
		]);
		
		$htmlHmin1Date = '

ORDER JATUH TEMPO H-1
';

		foreach ($orderDataHmin1Date as $key => $value) {
			$htmlHmin1Date .= $value->note .' ('.getTanggal($value->due_date).') ';
		}
		
		$result = sendWhatsApp('088232340119', $htmlTodayDueDate.$htmlHmin1Date);
		// $result = sendWhatsApp('08122680110', 'Hello World');
		// $result = sendWhatsApp('085736157112', 'Hello World');

		return $result;
	}

	public function index(){
		return "1";
	}

	public function approveBatchItemRequest(){

		$authorizationHeader = trim($this->request->getHeader("Authorization"));
        $this->accessToken = "";
        if (!empty($authorizationHeader)) {
            if (preg_match('/Bearer\s(\S+)/', $authorizationHeader, $matches)) {
                $this->accessToken = $matches[1];
            }
        }

        if ($this->accessToken != GUDANG_BATU_TOKEN) {
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.unauthorizedNoAccessToken')], $this->benchmark);
        }

        $batchCode = $this->request->getPost('batch_code', FILTER_SANITIZE_STRING);

        $batchItemModel = new BatchItemModel();

        $batchData = $batchItemModel->getAll(['where' => 'AND batches.batch_code="'.$batchCode.'" AND bi_active=1 ']);
		
		$batchItemRequestModel = new BatchItemRequestModel();

        if(empty($batchData)){
        	$batchCodeEx = explode('-', $batchCode);
        	$bitID = end($batchCodeEx);
        	$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Approved',
				'bir_active' => 1
			];

			$result = $batchItemRequestModel->updateBatchItemRequest($data, $bitID);

        }else{


	        $biData = [];
	        foreach ($batchData as $key => $value) {
	        	$biData[] = $value->id;
	        }

			$data = [
				'bir_update_at' => getCurrentTime(),
				'bir_update_admin_id' => $this->session->get('id'),
				'bir_status' => 'Approved',
				'bir_active' => 1
			];
			
			$result = $batchItemRequestModel->updateBatchItemRequestByBatchBulk($data, $biData);
        }


		if($result){
            return getResponse(200, "success", [(array)$result], $this->benchmark);
        }else{
            return getResponse(400, "failed", ['error_message' => lang('ErrorMessages.dataNotFound')], $this->benchmark);
        }
	}
}