<?php namespace App\Models;

class AdminPermissionModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param['select'];
        else        
            $query = 'SELECT 
                ap_id as "id", ap_insert_at as "insert_at",
                ap_role_id as "role_id", ar_name as "role_name", ar_slug as "role_slug",
                ap_admin_id as "admin_id", admin_fullname, admin_email 
            ';

        $query .= " FROM admin_permissions
            INNER JOIN admin_roles ON (ar_id=ap_role_id)
            INNER JOIN admins ON (admin_id=ap_admin_id)
            WHERE 1 ";

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND ap_active=1 AND ar_active=1 AND admin_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY ap_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        
            

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($permissionID){
        $param = array(
            'where' => ' AND ap_active=1 AND ar_active=1 AND admin_active=1 AND ap_id="'.$permissionID.'" ',
        );
        $result = $this->getAll($param);

        return $result;
    }  

    public function getByAdminID($adminID){
        if (!empty($param['select']))
            $query = 'SELECT '.$param['select'];
        else        
            $query = 'SELECT 
                ap_id as "id", ap_insert_at as "insert_at",
                ap_role_id as "role_id", ar_name as "role_name", ar_slug as "role_slug",
                am_id as "module_id", am_name as "module_name", am_slug as "module_slug",
                ap_admin_id as "admin_id", admin_fullname, admin_email 
            ';

        $query .= " FROM admin_permissions
            LEFT JOIN admin_roles ON (ar_id=ap_role_id)
            LEFT JOIN admin_role_modules ON (arm_role_id=ar_id)
            LEFT JOIN admin_modules ON (am_id=arm_module_id)
            LEFT JOIN admins ON (admin_id=ap_admin_id)
            WHERE 1 ";

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND ap_active=1 AND ar_active=1 AND arm_active=1 AND admin_active=1 AND ap_admin_id="'.$adminID.'" ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY am_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        
            

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();

        return $result;
    }

    public function addAdminPermission($data){
        
        $adminPermission = $this->db->table('admin_permissions');
        $adminPermission->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function updateAdminPermission($adminID, $roleID, $updateAdminID ){
        $data = [
            'ap_role_id'            => $roleID,
            'ap_update_admin_id'    => $updateAdminID,
            'ap_active'             => 1
        ];
        $this->db->table('admin_permissions')->where('ap_admin_id',$adminID)->update($data);
        $param = array(
            'where' => ' AND ap_admin_id="'.$adminID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteAdminPermission($adminID, $deleteAdminID ){
        $data = [
            'ap_delete_at'       => getCurrentTime(),
            'ap_delete_admin_id' => $deleteAdminID,
            'ap_active'          => 0
        ];

        $this->db->table('admin_permissions')->where('ap_admin_id',$adminID)->update($data);
        $param = array(
            'where' => ' AND ap_admin_id="'.$adminID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}