<?php namespace App\Models;

class BatchItemModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else

        $query = 'SELECT batch_items.bi_id as "id", batch_items.bi_tree_id as "tree_id", batch_items.bi_tree_weight as "tree_weight", batch_items.bi_tree_weight as "tree_weight",batch_items.bi_total_weight as "total_weight", batch_items.bi_stone_type as "stone_type", batch_items.bi_stone_quantity as "stone_quantity", batch_items.bi_stone_weight as "stone_weight", batch_items.bi_gold_weight as "gold_weight", trees.tree_name, items.item_sku as "sku", items.item_name as "name", categories.category_name, categories.category_id, gold_contents.gc_name, gold_contents.gc_id, gold_contents.gc_multiplier, gold_types.gt_id, gold_types.gt_name, items.item_weight as "weight", sizes.size_name, sizes.size_id, items.item_stone_type as "stone_type", order_items.oi_quantity as "quantity", order_items.oi_completed_quantity as "completed_quantity", orders.order_note, orders.order_date, items.item_use_wire as "use_wire", items.item_print_no as "print_no", batches.batch_start_date as "start_date", batches.batch_code, batches.batch_due_date as "due_date", customers.customer_name, order_items.oi_id as "order_item_id", order_items.oi_status as "order_item_status", batches.batch_status as "batch_status", batches.batch_is_print as "is_print", sizes.size_name, items.item_id, workflows.workflow_id as "workflow_id", items.item_image_1 as "image", customers.customer_name, customers.customer_address, customers.customer_phone, workflows.workflow_name, ins.admin_fullname as "user_insert", upd.admin_fullname as "user_update", del.admin_fullname as "user_delete", batch_total_weight as "total_weight", batch_total_stone_weight as "total_stone_weight", batch_total_gold_weight as "total_gold_weight" ';

        $query .= ' FROM batch_items 
            INNER JOIN batches ON batches.batch_id=batch_items.bi_batch_id 
            INNER JOIN order_items ON order_items.oi_id=batch_items.bi_oi_id
            INNER JOIN items ON items.item_id=order_items.oi_item_id 
            INNER JOIN orders ON orders.order_id=order_items.oi_order_id 
            LEFT JOIN trees ON trees.tree_id=batch_items.bi_tree_id 
            LEFT JOIN categories ON items.item_category_id=categories.category_id 
            LEFT JOIN sizes ON items.item_size_id=sizes.size_id
            LEFT JOIN gold_contents ON items.item_gc_id=gold_contents.gc_id 
            LEFT JOIN customers ON orders.order_customer_id=customers.customer_id
            LEFT JOIN gold_types ON items.item_gt_id=gold_types.gt_id 
            LEFT JOIN workflows ON workflows.workflow_id=items.item_workflow_id 
            LEFT JOIN workflow_tasks ON workflow_tasks.wt_workflow_id=workflows.workflow_id 
            LEFT JOIN tasks ON tasks.task_id=workflow_tasks.wt_task_id 
            LEFT JOIN admins ins ON ins.admin_id=batch_items.bi_insert_admin_id
            LEFT JOIN admins upd ON upd.admin_id=batch_items.bi_update_admin_id
            LEFT JOIN admins del ON del.admin_id=batch_items.bi_delete_admin_id
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND bi_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY bi_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($oiID){
        $param['where'] = ' AND bi_id='.$oiID.' AND bi_active=1 ';

        $result = $this->getAll($param);

        return $result;
    }

    public function getByBatchID($batchID){
        $param['where'] = ' AND bi_batch_id='.$batchID.' AND bi_active=1 ';

        $result = $this->getAll($param);

        return $result;
    }

    public function getByBatchIDStatus($batchID, $status){
        $param['where'] = ' AND bi_batch_id='.$batchID.' AND order_items.oi_status="'.$status.'" AND bi_active=1 ';

        $result = $this->getAll($param);

        return $result;
    }

    public function addBatchItem($data){
        $oi = $this->db->table('batch_items');
        $oi->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addBatchItemBulk($data){
        $oi = $this->db->table('batch_items');
        $oi->insertBatch($data);

        return $data;
    }

    public function updateBatchItem($data, $oiID){

        $this->db->table('batch_items')->where('bi_id',$oiID)->update($data);
        $param = array(
            'where' => ' AND bi_id="'.$oiID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function updateBatchItemBulk($data, $id){
        $oi = $this->db->table('batch_items');
        $oi->updateBatch($data, $id);

        return $data;
    }

    public function deleteOrder($oiID, $deleteAdminID ){
        $data = [
            'bi_delete_at'       => getCurrentTime(),
            'bi_delete_admin_id' => $deleteAdminID,
            'bi_active'          => 0
        ];

        $this->db->table('batch_items')->where('bi_id',$oiID)->update($data);
        $param = array(
            'where' => ' AND bi_id="'.$oiID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}