<?php namespace App\Models;

class batchModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT batch_id as "id", batch_code as "code", workflow_name, workflow_id, batch_start_date as "start_date", batch_due_date as "due_date", batch_status as "status", batch_total_weight as "total_weight", batch_total_stone_weight as "total_stone_weight", batch_total_gold_weight as "total_gold_weight", batch_insert_at as "insert_at", batch_is_print as "is_print", gc_id,  gc_name, gc_multiplier, tree_id, tree_name, tree_weight ';

        $query .= ' FROM batches 
            LEFT JOIN workflows ON workflows.workflow_id=batches.batch_workflow_id 
            LEFT JOIN gold_contents ON gold_contents.gc_id=batches.batch_gc_id 
            LEFT JOIN trees ON trees.tree_id=batches.batch_tree_id 
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND batch_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY batch_id ';


        if(!empty($param['orderby']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByCode($batchCode){

        $param['where'] = ' AND batch_code='.$batchCode.' AND batch_active=1 ';

        $result = $this->getAll($param);

        return $result[0];
    }

    public function getByID($batchID){

        $param['where'] = ' AND batch_id='.$batchID.' AND batch_active=1 ';

        $result = $this->getAll($param);

        return $result[0];
    }

    public function addBatch($data){
        $batches = $this->db->table('batches');
        $batches->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addBatchBulk($data){
        $batches = $this->db->table('batches');
        $batches->insertBatch($data);

        return $data;
    }

    public function updateBatches($data, $batchID){

        $this->db->table('batches')->where('batch_id',$batchID)->update($data);
        $param = array(
            'where' => ' AND batch_id="'.$batchID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deletebatch($batchID, $deleteAdminID ){
        $data = [
            'batch_delete_at'       => getCurrentTime(),
            'batch_delete_admin_id' => $deleteAdminID,
            'batch_active'          => 0,
            'batch_status'          => 'Deleted'
        ];

        $this->db->table('batches')->where('batch_id',$batchID)->update($data);
        $param = array(
            'where' => ' AND batch_id="'.$batchID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteItemBatchByBatch($batchID, $deleteAdminID ){
       $data = [
            'bi_delete_at'       => getCurrentTime(),
            'bi_delete_admin_id' => $deleteAdminID,
            'bi_active'          => 0
        ];

        $this->db->table('batch_items')->where('bi_batch_id',$batchID)->update($data);
        $param = array(
            'where' => ' AND batch_id="'.$batchID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result; 
    }

}