<?php namespace App\Models;

class ItemModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            // item_sku    item_name   item_workflow_id    item_category_id    item_gc_id  item_weight item_size_id    item_stone_type item_use_wire   item_image_1    item_image_2    item_image_3    item_print_no   item_cad_file

            $query = 'SELECT items.item_id as "id", items.item_sku as "sku", items.item_name as "name", items.item_weight as "weight", items.item_stone_type as "stone_type",items.item_use_wire as "use_wire",items.item_image_1, items.item_print_no as "print_no", items.item_cad_file as "cad_file", items.item_image_1 as "image", workflows.workflow_name as "workflow_name", workflows.workflow_id, categories.category_name as "category_name", categories.category_id, gold_contents.gc_id, gold_contents.gc_name as "gc_name", gold_types.gt_id, gold_types.gt_name, sizes.size_id, sizes.size_name as "size_name", item_insert_at as "insert_at", items.item_gt_id as "gt_id" ';

        $query .= ' FROM items
        LEFT JOIN workflows ON items.item_workflow_id=workflows.workflow_id 
        LEFT JOIN categories ON items.item_category_id=categories.category_id 
        LEFT JOIN sizes ON items.item_size_id=sizes.size_id
        LEFT JOIN gold_contents ON items.item_gc_id=gold_contents.gc_id
        LEFT JOIN gold_types ON items.item_gt_id=gold_types.gt_id 
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND item_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY item_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByID($itemID){

        $param = [
            'where' => ' AND item_id="'.$itemID.'" AND item_active=1' 
        ];
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function getBySKU($itemSKU){

        $param = [
            'where' => ' AND item_sku="'.$itemSKU.'" AND item_active=1' 
        ];
        $result = $this->getAll($param);
        
        return $result;
    }

    public function addItem($data){
        $items = $this->db->table('items');
        $items->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addItemBulk($data){
        $orders = $this->db->table('items');
        $orders->insertBatch($data);

        return $data;
    }

    public function updateItem($data, $itemID){

        $this->db->table('items')->where('item_id',$itemID)->update($data);
        $param = array(
            'where' => ' AND item_id="'.$itemID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
    }

    public function deleteItem($itemID, $deleteAdminID ){
        $data = [
            'item_delete_at'       => getCurrentTime(),
            'item_delete_admin_id' => $deleteAdminID,
            'item_active'          => 0
        ];

        $this->db->table('items')->where('item_id',$itemID)->update($data);
        $param = array(
            'where' => ' AND item_id="'.$itemID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}