<?php namespace App\Models;

class TreeModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT tree_id as "id", tree_code as "code", tree_name as "name", tree_weight as "weight", tree_insert_at as "insert_at" ';

        $query .= ' FROM trees
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND tree_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY tree_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND tree_active="1" AND tree_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function getByID($treeID){
        $trees = $this->db->table('trees');
        $trees->select('tree_id as "id", tree_code as "code", tree_name as "name", tree_weight as "weight", tree_insert_at as "insert_at" ');
        $trees->where('tree_id', $treeID);
        $trees->where('tree_active', 1);

        $result = $trees->get()->getRow();

        return $result;
    }

    public function addTree($data){
        $trees = $this->db->table('trees');
        $trees->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function addTreeHistory($data){
        $trees = $this->db->table('tree_histories');
        $trees->insert($data);
        $result = $this->db->insertID();

        return $result;
    }

    public function updateTree($data, $treeID){

        $this->db->table('trees')->where('tree_id',$treeID)->update($data);
        $param = array(
            'where' => ' AND tree_id="'.$treeID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteTree($treeID, $deleteAdminID ){
        $data = [
            'tree_delete_at'       => getCurrentTime(),
            'tree_delete_admin_id' => $deleteAdminID,
            'tree_active'          => 0
        ];

        $this->db->table('trees')->where('tree_id',$treeID)->update($data);
        $param = array(
            'where' => ' AND tree_id="'.$treeID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}