<?php namespace App\Models;

class WorkflowModel extends BaseModel
{
    public function __construct(){
        parent::__construct();
    }

    public function getAll($param=array()){
        if (!empty($param['select']))
            $query = 'SELECT '.$param["select"];
        else
            $query = 'SELECT workflow_id as "id", workflow_code as "code", workflow_name as "name", workflow_insert_at as "insert_at" ';

        $query .= ' FROM workflows
            WHERE 1 ';

        if(!empty($param['where']))
            $query .= ' '.$param['where'];
        else
            $query .= ' AND workflow_active=1 ';

        if(!empty($param['groupby']))
            $query .= ' GROUP BY '.$param['groupby'];

        else
            $query .= ' GROUP BY workflow_id ';


        if(!empty($param['orderBy']))
            $query .= ' ORDER BY '.$param['orderby'];
        else
            $query .= ' ORDER BY 1 DESC';

        if(!empty($param['limit']))
            $query .= ' LIMIT '.$param['limit'];
        else
            $query .= '';

        if(!empty($param['resultType'])) 
            return $this->db->query($query);
        else
            return $this->db->query($query)->getResult();
    }

    public function getByCode($code){
        $param = array(
            'where' => ' AND workflow_active="1" AND workflow_code="'.$code.'" ',
        );
        $result = $this->getAll($param);
        
        return $result;
    }

    public function getWorkflowTaskGetByWorkflow($workflowID){
       $query = 'SELECT wt_task_id as "task_id", wt_order as "order", workflow_id, workflow_code as "code", workflow_name as "name", tasks.task_name FROM workflow_tasks JOIN workflows ON workflows.workflow_id=workflow_tasks.wt_workflow_id JOIN tasks ON tasks.task_id=workflow_tasks.wt_task_id
            WHERE wt_workflow_id="'.$workflowID.'" AND wt_active=1 ORDER BY wt_order';   

        return $this->db->query($query)->getResult();
    }

    public function getWorkflowTaskGetByWorkflowRange($workflowID, $from=0, $to=0){
       $query = 'SELECT wt_task_id as "task_id", wt_order as "order", workflow_id, workflow_code as "code", workflow_name as "name", tasks.task_name FROM workflow_tasks JOIN workflows ON workflows.workflow_id=workflow_tasks.wt_workflow_id JOIN tasks ON tasks.task_id=workflow_tasks.wt_task_id
            WHERE wt_workflow_id="'.$workflowID.'" AND wt_order >= "'.$from.'" AND wt_order <= "'.$to.'" AND wt_active=1 ORDER BY wt_order';   

        return $this->db->query($query)->getResult();
    }

    public function getWorkflowTaskGetByWorkflowRangeUp($workflowID, $from=0){
       $query = 'SELECT wt_task_id as "task_id", wt_order as "order", workflow_id, workflow_code as "code", workflow_name as "name", tasks.task_name FROM workflow_tasks JOIN workflows ON workflows.workflow_id=workflow_tasks.wt_workflow_id JOIN tasks ON tasks.task_id=workflow_tasks.wt_task_id
            WHERE wt_workflow_id="'.$workflowID.'" AND wt_order >= "'.$from.'" AND wt_active=1 ORDER BY wt_order';   

        return $this->db->query($query)->getResult();
    }

    public function getWorkflowTaskGetByWorkflowRangeDown($workflowID, $from){
       $query = 'SELECT wt_task_id as "task_id", wt_order as "order", workflow_id, workflow_code as "code", workflow_name as "name", tasks.task_name FROM workflow_tasks JOIN workflows ON workflows.workflow_id=workflow_tasks.wt_workflow_id JOIN tasks ON tasks.task_id=workflow_tasks.wt_task_id
            WHERE wt_workflow_id="'.$workflowID.'" AND wt_order <= "'.$from.'" AND wt_active=1 ORDER BY wt_order';   

        return $this->db->query($query)->getResult();
    }

    public function getByID($workflowID){
        $workflows = $this->db->table('workflows');
        $workflows->select('workflow_id as "id", workflow_code as "code", workflow_name as "name", workflow_insert_at as "insert_at" ');
        $workflows->where('workflow_id', $workflowID);
        $workflows->where('workflow_active', 1);

        $result = $workflows->get()->getRow();

        return $result;
    }

    public function addWorkflow($data){
        $workflows = $this->db->table('workflows');
        $workflows->insert($data);
        $result = $this->db->insertID();

        return $result;
    }


    public function addWorkflowTaskBluk($data){
        $workflows = $this->db->table('workflow_tasks');
        $workflows->insertBatch($data);
        return $data;
    }

    public function updateWorkflow($data, $workflowID){

        $this->db->table('workflows')->where('workflow_id',$workflowID)->update($data);
        $param = array(
            'where' => ' AND workflow_id="'.$workflowID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

    public function deleteWorkflow($workflowID, $deleteAdminID ){
        $data = [
            'workflow_delete_at'       => getCurrentTime(),
            'workflow_delete_admin_id' => $deleteAdminID,
            'workflow_active'          => 0
        ];

        $this->db->table('workflows')->where('workflow_id',$workflowID)->update($data);
        $param = array(
            'where' => ' AND workflow_id="'.$workflowID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }


    public function deleteWorkflowTask($workflowID, $deleteAdminID ){
        $data = [
            'wt_delete_at'       => getCurrentTime(),
            'wt_delete_admin_id' => $deleteAdminID,
            'wt_active'          => 0
        ];

        $this->db->table('workflow_tasks')->where('wt_workflow_id',$workflowID)->update($data);
        $param = array(
            'where' => ' AND workflow_id="'.$workflowID.'" ',
        );
        $result = $this->getAll($param);
        if ($result)
            $result = $result[0];

        return $result;
        
    }

}