<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Tambah</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/batch" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<form action="" class="submit">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
									<div class="form-group my-3 col-md-7">
										<label>Tanggal Mulai</label>
										<input type="date" name="start_date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Batas Waktu Tanggal</label>
										<input type="date" name="due_date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Pohon</label>
										<select name="tree_id" class="form-control mt-1" placeholder="">
											<option value="">-- Pilih --</option>
											<?php foreach ($data_tree as $key => $value): ?>
												<option value="<?= $value->id ?>"><?= $value->name ?>  [ Berat : <?= $value->weight ?> ]</option>
											<?php endforeach ?>
											<input type="hidden" name="tree_weight" id="tree_weight">
										</select>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Kadar Emas</label>
										<select name="gc_id" class="form-control mt-1" placeholder="">
											<option value="">-- Pilih --</option>
											<?php foreach ($data_gc as $key => $value): ?>
												<option value="<?= $value->id ?>"><?= $value->name ?> [ Multiplier : <?= $value->multiplier ?> ]</option>
											<?php endforeach ?>
										</select>
										<input type="hidden" name="gc_multiplier" id="gc_multiplier">
									</div>
									<button type="button" class="btn btn-sm btn-primary kt_modal_1_add">
									    Tambah Order Nota
									</button>
									<div class="table-responsive">
										<table class="table table table-striped table-bordered gy-5 gs-7">
											<thead>
												<tr>
													<th></th>
													<th class="min-w-250px">Barang</th>
													<th class="min-w-100px">Nota</th>
													<th class="min-w-50px">Jumlah</th>
													<th class="min-w-100px">Jumlah Batu</th>
												</tr>
											</thead>
											<tbody id="response-data-order">
											</tbody>
										</table>
									</div>
									<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
								</div>
								<!--end: Card Body-->
							</div>
						<!--end: List Widget 5-->
						</form> 
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->

	<div class="modal fade" tabindex="-1" id="kt_modal_1">
	    <div class="modal-dialog modal-xl">
	        <div class="modal-content">
	            <div class="modal-header">
	                <h5 class="modal-title">Order Barang</h5>

	                <!--begin::Close-->
	                <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
	                    <span class="svg-icon svg-icon-2x"></span>
	                </div>
	                <!--end::Close-->
	            </div>

	            <div class="modal-body">
	            	<form action="" id="submit-select-order-item" class="submit-select-order-item">
		            	<div class="d-flex align-items-center position-relative my-1">
							<span class="svg-icon svg-icon-2 svg-icon-lg-1 svg-icon-gray-500 position-absolute top-50 translate-middle-y ms-3">
									<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
										<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
											<rect x="0" y="0" width="24" height="24" />
											<path d="M14.2928932,16.7071068 C13.9023689,16.3165825 13.9023689,15.6834175 14.2928932,15.2928932 C14.6834175,14.9023689 15.3165825,14.9023689 15.7071068,15.2928932 L19.7071068,19.2928932 C20.0976311,19.6834175 20.0976311,20.3165825 19.7071068,20.7071068 C19.3165825,21.0976311 18.6834175,21.0976311 18.2928932,20.7071068 L14.2928932,16.7071068 Z" fill="#000000" fill-rule="nonzero" opacity="0.3" />
											<path d="M11,16 C13.7614237,16 16,13.7614237 16,11 C16,8.23857625 13.7614237,6 11,6 C8.23857625,6 6,8.23857625 6,11 C6,13.7614237 8.23857625,16 11,16 Z M11,18 C7.13400675,18 4,14.8659932 4,11 C4,7.13400675 7.13400675,4 11,4 C14.8659932,4 18,7.13400675 18,11 C18,14.8659932 14.8659932,18 11,18 Z" fill="#000000" fill-rule="nonzero" />
										</g>
									</svg>
								</span>
					        <input type="text" data-kt-docs-table-filter="search" class="form-control form-control-solid w-400px ps-15" placeholder="Search <?= @$title ?>"/>
					    </div>
		                <table class="table table table-striped table-bordered gy-5 gs-7" id="kt_datatable3">
							<thead>
								<tr>
									<th class="min-w-50px">
										<div class="form-check form-check-custom form-check-solid form-check-sm">
										    <input id="select-all" class="form-check-input" type="checkbox" value=""/>
										    <label class="form-check-label" for="flexRadioLg">
										        All
										    </label>
										</div>
									</th>
									<th class="min-w-100px">Order Nota</th>
									<th class="min-w-200px">Barang</th>
									<th class="min-w-100px">Pelanggan</th>
									<th class="min-w-100px">Jumlah Order</th>
									<th class="min-w-100px">Jumlah Batu</th>
									<th class="min-w-200px">Tanggal</th>
								</tr>
							</thead>
							<tbody>

							</tbody>
						</table>
		            </div>
	            </form>

	            <div class="modal-footer">
	                <button type="button" class="btn btn-light" data-bs-dismiss="modal">Close</button>
	                <button form="submit-select-order-item" type="submit" class="btn btn-primary">Tambah</button>
	            </div>
	        </div>
	    </div>
	</div>

<?= $this->endSection() ?>

<?= $this->section('js') ?>
<script type="text/javascript">
	let array_order_item_id = [];

	$(document).on('click', '.kt_modal_1_add', function(){
		var gcID = $('select[name="gc_id"]').val();
		if (gcID == '') {
			return alert('Pilih kadar emas terlebih dahulu !')
		}

		$('.array-order-item-id').each(function(key, value){
			if (array_order_item_id.includes(value.value) == false) {
				array_order_item_id.push(value.value)
			}
		})

		resultOI = array_order_item_id.join();

		$('#kt_datatable3').DataTable().ajax.url("<?= base_url() ?>/batch?act=orderItemData&gc_id="+gcID+"&oi_id="+resultOI).load();

		$('#kt_modal_1').modal('show')
	})

	$(document).on('click', '.order-item-id', function(){
		id = $(this).val()
		if($(this).prop('checked')){
			if (array_order_item_id.includes(parseInt(id)) == false) {
				array_order_item_id.push(parseInt(id))
			}
		}else{
			var index = array_order_item_id.indexOf(id);
			array_order_item_id.splice(index, 1);
		}

	})

	$(document).on('change', 'select[name="gc_id"]', function(){
		$('#response-data-order').html('')
		array_order_item_id = [];
	})

	$(document).ready(function(){

	    var gcID = $('select[name="gc_id"]').val();
	    resultOI = array_order_item_id.join();
		"use strict";

		// Class definition
		var KTDatatablesServerSide = function () {
	    // Shared variables
	    var table;
	    var dt;

	    // Private functions
	    var initDatatable = function () {
	        dt = $("#kt_datatable3").DataTable({
	            responsive:false,
	            // searchDelay: 500,
	            processing: true,
	            serverSide: true,
	            ordering :false,
	            select: {
	                style: 'os',
	                selector: 'td:first-child',
	                className: 'row-selected'
	            },
	            ajax: {
	                url: "<?= base_url() ?>/batch?act=orderItemData&gc_id="+gcID+"&oi_id="+resultOI,
	            },
	            columns: [
	                {data: 'checkbox'},
	                {data: 'order_note'},
	                {data: 'name'},
		            {data: 'customer_name'},
	                {data: 'quantity'},                
		            {data: 'stone_quantity'},
		            {data: 'date'},
	            ],
	        });

	        table = dt.$;

	        // Re-init functions on every table re-draw -- more info: https://datatables.net/reference/event/draw
	        dt.on('draw', function () {
	            initToggleToolbar();
	            toggleToolbars();
	            KTMenu.createInstances();

	            checkedInput();
	        });
	    }

	    var handleSearchDatatable = function () {
	        const filterSearch = document.querySelector('[data-kt-docs-table-filter="search"]');
	        filterSearch.addEventListener('keyup', function (e) {
	            dt.search(e.target.value).draw();

	            checkedInput();
	        });
	    }

	    // Init toggle toolbar
	    var initToggleToolbar = function () {
	        const container = document.querySelector('#kt_datatable3');
	        const checkboxes = container.querySelectorAll('[type="checkbox"]');

	        // Toggle delete selected toolbar
	        checkboxes.forEach(c => {
	            // Checkbox on click event
	            c.addEventListener('click', function () {
	                setTimeout(function () {
	                    toggleToolbars();
	                }, 50);
	            });
	        });
	    }

		    // Toggle toolbars
		    var toggleToolbars = function () {
		        // Define variables
		        const container = document.querySelector('#kt_datatable3');
		        const toolbarBase = document.querySelector('[data-kt-docs-table-toolbar="base"]');
		        const toolbarSelected = document.querySelector('[data-kt-docs-table-toolbar="selected"]');
		        const selectedCount = document.querySelector('[data-kt-docs-table-select="selected_count"]');

		        var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
		        var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
		            return new bootstrap.Tooltip(tooltipTriggerEl)
		        })

		    }

		    var checkedInput = function(){
		    	$.each(array_order_item_id, function(key, value){
					$('.checked-'+value).attr('checked', true)
				})
		    }

		    // Public methods
		    return {
		        init: function () {
		            initDatatable();
		            handleSearchDatatable();
		            initToggleToolbar();
		            checkedInput();
		        }
		    }
		}();

		// On document ready
		KTUtil.onDOMContentLoaded(function () {
		    KTDatatablesServerSide.init();
		});
	});

	$(document).on('change keyup', '.sum-quantity', function(){

		var weight_tree = $('input[name="tree_weight"]').val();

		var total_weight_tree = $('input[name="tree_total_weight"]').val();
		var total_stone_quantity = 0;
		var total_stone_weight = 0;

		var gc_multiplier = $('input[name="gc_multiplier"]').val();

		if(gc_multiplier == ''){
			gc_multiplier = 0; 
		}

		var difference = total_weight_tree-weight_tree;
		
		$('.row-item').each(function(key, value){
		 	var stone_quantity = $(this).find('.stone-quantity').val();
		 	var stone_weight = $(this).find('.stone-weight').val();

		 	if(stone_quantity == ''){
		 		stone_quantity = 0; 
		 	}

		 	if(stone_weight == ''){
		 		stone_weight = 0; 
		 	}

		 	total_stone_quantity += parseFloat(stone_quantity);
		 	total_stone_weight += parseFloat(stone_weight);
		});

		$('input[name="total_stone_weight"]').val(total_stone_weight);

		$('input[name="gold_weight"]').val((difference-total_stone_weight)*parseFloat(gc_multiplier));

	})

	$(document).on('change', 'select[name="tree_id"]', function(){
		value = $(this).val();

		$.ajax({
			type: 'get',
			url: "<?= base_url() ?>/batch?paramType=treeByID",
			data : {tree_id:value},
		    dataType : 'JSON',
		    success: function(response){
		    	// console.log(response)
		    	$('input[name="tree_weight"]').val(response.weight);
		    },
		})
	})


	$(document).on('change', 'select[name="gc_id"]', function(){
		value = $(this).val();

		$.ajax({
			type: 'get',
			url: "<?= base_url() ?>/batch?paramType=gcByID",
			data : {gc_id:value},
		    dataType : 'JSON',
		    success: function(response){
		    	// console.log(response)
		    	$('input[name="gc_multiplier"]').val(response.multiplier);
		    },
		})
	})


	$(document).on('click', '.result-order-item-id', function(){
		if($(this).prop('checked') == false){
			$(this).parents('tr').remove();
		}
	})

	$(document).on('click', '.page-link', function(){
		
		$("#select-all").prop('checked', false)
		
	})

	function searchNote(data){
		gcID = $('select[name="gc_id"]').val();
		$('#kt_datatable3').DataTable().ajax.url("<?= base_url() ?>/batch?act=orderItemData&gc_id="+gcID+"&note="+data).load();
	}

	$('#select-all').click(function(event) {
	    if (this.checked) {
	      // Iterate each checkbox
		    $(':checkbox').each(function() {
		        this.checked = true;
		    });

		    $('.order-item-id').each(function(key, value){
				if (array_order_item_id.includes(value.value) == false) {
					array_order_item_id.push(value.value)
				}
			})

	    } else {
	      $(':checkbox').each(function() {
	        this.checked = false;
	      });
	    }


	});


	$('#kt_datatable3').on('keyup change', '.trigger', function(e) {
	  	var rowTr = $(this).parents('tr');
	  	var weight_tree = rowTr.find('.weight-tree').val();
		var total_weight_tree = rowTr.find('.total-weight-tree').val();
		var weight_gold_1 = total_weight_tree-weight_tree;
		var stone_quantity = rowTr.find('.stone-quantity').val();
		var stone_weight = rowTr.find('.stone-weight').val();
		var multiplier = rowTr.find('.multiplier').val();

      	if (stone_weight == '') {
      		stone_weight = 0;
      	}

        var gold_weight = rowTr.find('.gold-weight').val((weight_gold_1-stone_weight)*multiplier);

	});

	$('#kt_datatable3').on('keyup change', '.select-tree', function(e) {
	  	 $('.option-trees').removeClass('d-none');
	  	 var rowTr = $(this).parents('tr');
	  	 var value = $(this).val();

	  	 var thisData = $(this);

	  	 var treeData = $('.select-tree');

	  	 treeData.each(function(key, value){
	  	 	$('.option-tree'+value.value).addClass('d-none')
	  	 });

	  	 $(this).find('.option-tree'+value).removeClass('d-none')

	  	 if (value != '') {
		  	 $.ajax({
		          type : 'get',
		          url : '<?= base_url() ?>/batch?act=treeData',
		          data : {tree_id:value},
		          dataType : 'JSON',
		          beforeSend : function(){
		            rowTr.find('.weight-tree-load').attr('data-kt-indicator', 'on');
		            rowTr.find('.weight-tree-load').attr('disabled', '');
		            rowTr.find('.weight-tree-load').html('<span class="indicator-progress">\
		                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
		                    </span>');
		          },
		          complete : function(response){
		            rowTr.find('.weight-tree-load').removeAttr('disabled', '');
		            rowTr.find('.weight-tree-load').removeAttr('data-kt-indicator');
		            rowTr.find('.weight-tree-load').html('');
		          },
		          success: function(response){
		          	rowTr.find('.weight-tree').val(response.weight);
		          	rowTr.find('.weight-tree').removeClass('d-none');
		          	rowTr.find('.total-weight-tree').removeClass('d-none');
		          	rowTr.find('.stone-quantity').removeClass('d-none');
		          	rowTr.find('.stone-weight').removeClass('d-none');
		          	rowTr.find('.gold-weight').removeClass('d-none');
		          },
		          error: function (xhr, ajaxOptions, thrownError){
		            alert(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
		          }

		    });
	  	 }else{
	  	 	rowTr.find('.weight-tree').val('');
	  	 	rowTr.find('.weight-tree').addClass('d-none');
          	rowTr.find('.total-weight-tree').addClass('d-none');
          	rowTr.find('.stone-quantity').addClass('d-none');
          	rowTr.find('.stone-weight').addClass('d-none');
          	rowTr.find('.gold-weight').addClass('d-none');
	  	 }

	  });

	$('.submit-select-order-item').submit(function(e){
		e.preventDefault()

        
        $('#response-data-order').html('');

		btn = $('.submit-select-order-item button[type="submit"]').html();

		resultOI = array_order_item_id.join();

		$.ajax({
          type : 'get',
          url : '<?= base_url() ?>/batch?act=orderItemByCheck&order_item_id='+resultOI,
          dataType : 'JSON',
          processData: false,
          contentType: false,
          beforeSend : function(){
            $('.submit-select-order-item button[type="submit"]').attr('data-kt-indicator', 'on');
            $('.submit-select-order-item button[type="submit"]').attr('disabled', '');
            $('.submit-select-order-item button[type="submit"]').html('<span class="indicator-progress">\
                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            $('.submit-select-order-item button[type="submit"]').removeAttr('disabled', '');
            $('.submit-select-order-item button[type="submit"]').removeAttr('data-kt-indicator');
            $('.submit-select-order-item button[type="submit"]').html(btn);
          },
          success: function(response){
          	if (response.error) {
              return alertToastr('error', response.error);
            }else if(response.success){
              return alertToastr('success', response.success);
            }

          	 $('#response-data-order').html(response.data)
          	 $('#kt_modal_1').modal('hide')

          },
          error: function (xhr, ajaxOptions, thrownError){
            console.log(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }
        });
	})



</script>
<?= $this->endSection() ?>