<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Edit</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/batch" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<form action="" class="submit">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
									<div class="form-group my-3 col-md-7">
										<label>Tanggal Mulai</label>
										<input type="date" name="start_date" value="<?=  $data->start_date ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Batas Waktu Tanggal</label>
										<input type="date" name="due_date" value="<?= $data->due_date ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Pohon</label>
										<select name="tree_id" class="form-control select-tree mt-1 sum-quantity" placeholder="">
											<option value="">-- Pilih --</option>
											<?php foreach ($data_tree as $key => $value): ?>
												<option <?= ($value->id == $data->tree_id)? 'selected':''; ?> value="<?= $value->id ?>"><?= $value->name ?>  [ Berat : <?= $value->weight ?> ]</option>
											<?php endforeach ?>
											<input type="hidden" name="tree_weight" value="<?= $data->tree_weight ?>" id="tree_weight">
										</select>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Total Berat Pohon</label>
										<input type="text" name="total_weight" value="<?= $data->total_weight ?>" class="form-control sum-quantity mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Kadar Emas</label>
										<input name="gc_name" value="<?= $data->gc_name ?> - <?= $data->gc_multiplier ?>" class="form-control" readonly>
										<input name="gc_id" type="hidden" value="<?= $data->gc_id ?> " class="form-control" readonly>
										<input type="hidden" name="gc_multiplier" id="gc_multiplier" value="<?= $data->gc_multiplier ?>">
									</div>
									<div class="table-responsive">
										<table class="table table table-striped table-bordered gy-5 gs-7">
											<thead>
												<tr>
													<th></th>
													<th class="min-w-250px">Barang</th>
													<th class="min-w-100px">Nota</th>
													<th class="min-w-50px">Jumlah</th>
													<th class="min-w-100px">Jumlah Batu</th>
													<th class="min-w-50px">Berat Batu</th>
												</tr>
											</thead>
											<tbody id="response-data-order">
												<?php foreach ($data_batch_item as $key => $value): ?>
												<tr class="row-item">
													<td>
															<?= ($key+1) ?>
														  <input checked value="<?= $value->id ?>" name="batch_item_id[]" type="hidden" value="" id="flexRadioLg<?= $value->id ?>"/>
													</td>
													<td class="min-w-100px">
													SKU : <?= $value->sku ?><br>
													Barang : <?= $value->name ?><br>
													Pelanggan : <?= $value->customer_name ?><br>
													Alur Kerja : <?= $value->workflow_name ?><br>
													Jumlah Order: <?= $value->quantity ?><br>
													Tanggal Mulai : <?= $value->start_date ?> <br>
													Tenggat Waktu: <?= $value->due_date ?><br>
													</td>
													<td class="min-w-100px"><?=$value->order_note ?></td>
													<td class="min-w-100px"><?= $value->quantity ?></td>
													<td class="min-w-100px"><a href="javascript:void(0)" data-id="<?= $value->id ?>" class="kt_modal_1_detail" ><?= $value->stone_quantity ?></a>
														<input type="hidden" class="sum-quantity stone-quantity" name="stone_quantity[<?= $value->id ?>]" value="<?= ($value->quantity) ?>">
													</td>
													<td class="min-w-200px">
														<input type="number" step="any" readonly class="form-control bg-light w-150px sum-weight-<?= $value->id ?> sum-quantity stone-weight" value="<?= (@$value->stone_weight)? $value->stone_weight : 0; ?>" name="stone_weight[<?= $value->id ?>]">
														<?php if ($value->stone_quantity > 0): ?>
															<a href="javascript:void(0)" data-id="<?= $value->id ?>" class="kt_modal_1_detail btn btn-icon btn-success mt-2" ><i class="fa fa-edit"></i></a>
														<?php endif ?>
													</td>
												</tr>
												<?php endforeach ?>
											</tbody>
										</table>
									</div>

									<div class="form-group my-3 col-md-7">
										<label>Berat Batu</label>
										<input type="number" name="total_stone_weight" step="any" readonly class="form-control mt-1 form-control-solid" placeholder=""/>
									</div>

									<div class="form-group my-3 col-md-7">
										<label>Berat Emas</label>
										<input type="text" name="gold_weight" step="any" readonly class="form-control mt-1 form-control-solid" placeholder=""/>
									</div>
									<div class="mt-2" hidden>
										<div class="form-check form-check-custom form-check-solid form-check-sm">
										    <input id="select-all" class="form-check-input" name="start_batch" type="checkbox" value="1"/>
										    <label class="form-check-label" for="flexRadioLg">
										        Start Batch Sekarang
										    </label>
										</div>
									</div>
									<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
								</div>
								<!--end: Card Body-->
							</div>
						<!--end: List Widget 5-->
						</form> 
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->

	<div class="modal fade" tabindex="-1" id="kt_modal_1">
	    <div class="modal-dialog modal-lg">
	        <div class="modal-content">
	            <div class="modal-header">
	                <h5 class="modal-title">Detail Batu</h5><div class="d-flex align-items-center position-relative my-0">
										<span class="svg-icon svg-icon-2 svg-icon-lg-1 svg-icon-gray-500 position-absolute top-50 translate-middle-y ms-3">
												<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
													<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
														<rect x="0" y="0" width="24" height="24" />
														<path d="M14.2928932,16.7071068 C13.9023689,16.3165825 13.9023689,15.6834175 14.2928932,15.2928932 C14.6834175,14.9023689 15.3165825,14.9023689 15.7071068,15.2928932 L19.7071068,19.2928932 C20.0976311,19.6834175 20.0976311,20.3165825 19.7071068,20.7071068 C19.3165825,21.0976311 18.6834175,21.0976311 18.2928932,20.7071068 L14.2928932,16.7071068 Z" fill="#000000" fill-rule="nonzero" opacity="0.3" />
														<path d="M11,16 C13.7614237,16 16,13.7614237 16,11 C16,8.23857625 13.7614237,6 11,6 C8.23857625,6 6,8.23857625 6,11 C6,13.7614237 8.23857625,16 11,16 Z M11,18 C7.13400675,18 4,14.8659932 4,11 C4,7.13400675 7.13400675,4 11,4 C14.8659932,4 18,7.13400675 18,11 C18,14.8659932 14.8659932,18 11,18 Z" fill="#000000" fill-rule="nonzero" />
													</g>
												</svg>
											</span>
									      <input type="text" data-kt-docs-table-filter="search" class="form-control form-control-solid w-500px ps-15" placeholder="Search"/>
									  </div>

	                <!--begin::Close-->
	                <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
	                    <span class="svg-icon svg-icon-2x"></span>
	                </div>
	                <!--end::Close-->
	            </div>
	            <div class="modal-body">
	            		<form class="submit-material-weight">
										<table id="kt_datatable_material" class="table table-striped table-row-bordered gy-5 gs-7">
										    <thead>
										        <tr class="fw-bold fs-6 text-gray-800">
										            <th class="min-w-10px">No</th>
										            <th class="min-w-50px">SKU</th>
										            <th class="min-w-100px">Nama Barang</th>
										            <th class="min-w-100px">Source</th>
										            <th class="min-w-100px">Jumlah</th>
										            <th class="min-w-100px">Weight</th>
										            <th class="min-w-100px">Status</th>
										        </tr>
										    </thead>
										    <tbody>
										    	
										    </tbody>
										</table>
	            		</form>
	            </div>
	        </div>
	    </div>
	</div>

<?= $this->endSection() ?>

<?= $this->section('js') ?>
<script type="text/javascript">
	let array_order_item_id = [];

	$(document).on('click', '.order-item-id', function(){
		id = $(this).val()
		if($(this).prop('checked')){
			if (array_order_item_id.includes(parseInt(id)) == false) {
				array_order_item_id.push(parseInt(id))
			}
		}else{
			var index = array_order_item_id.indexOf(id);
			array_order_item_id.splice(index, 1);
		}

	})

	$(document).on('change', 'gc_id', function(){
		$('#response-data-order').html('')
	})

	$(document).ready(function(){
		sum()
	})

	$(document).on('change keyup', '.sum-quantity', function(){
		sum()
	})

function sum(){
		var weight_tree = $('input[name="tree_weight"]').val();

		var total_weight_tree = $('input[name="total_weight"]').val();
		var total_stone_quantity = 0;
		var total_stone_weight = 0;

		var gc_multiplier = $('input[name="gc_multiplier"]').val();

		if(gc_multiplier == ''){
			gc_multiplier = 0; 
		}

		var difference = total_weight_tree-weight_tree;
		// console.log(difference);
		$('.row-item').each(function(key, value){
		 	var stone_quantity = $(this).find('.stone-quantity').val();
		 	var stone_weight = $(this).find('.stone-weight').val();

		 	if(stone_quantity == ''){
		 		stone_quantity = 0; 
		 	}

		 	if(stone_weight == ''){
		 		stone_weight = 0; 
		 	}

		 	total_stone_quantity += parseFloat(stone_quantity);
		 	total_stone_weight += parseFloat(stone_weight); 
		});

		$('input[name="total_stone_weight"]').val(total_stone_weight);

		let gold_weight = (difference-total_stone_weight)*parseFloat(gc_multiplier)

		$('input[name="gold_weight"]').val(gold_weight.toFixed(2));

}

$(document).on('change keyup', '.item_weight', function(){
		var id = $(this).data('id');
		var bi_id = $(this).data('bi_id');
		var val = $(this).val();

		$.ajax({
			type: 'POST',
			url: "<?= base_url() ?>/batch-item-request/"+id+"?param_type=updateWeight",
			data : $('.submit-material-weight').serialize()+'&bi_id='+bi_id+'&weight='+val,
	    dataType : 'JSON',
	    success: function(response){
	    	// console.log(response.data)
	    	$('.sum-weight-'+bi_id).val(response.data)

	    	sum()
	    },

		})

})

	$(document).on('change', 'select[name="tree_id"]', function(){
		value = $(this).val();

		$.ajax({
			type: 'get',
			url: "<?= base_url() ?>/batch?paramType=treeByID",
			data : {tree_id:value},
		    dataType : 'JSON',
		    success: function(response){
		    	console.log(response.weight)
		    	$('input[name="tree_weight"]').val(response.weight);
		    },
		})
	})


	$(document).on('change', 'select[name="gc_id"]', function(){
		value = $(this).val();

		$.ajax({
			type: 'get',
			url: "<?= base_url() ?>/batch?paramType=gcByID",
			data : {gc_id:value},
		    dataType : 'JSON',
		    success: function(response){
		    	// console.log(response)
		    	$('input[name="gc_multiplier"]').val(response.multiplier);
		    },
		})
	})


	$(document).on('click', '.result-order-item-id', function(){
		if($(this).prop('checked') == false){
			$(this).parents('tr').remove();
		}
	})

	$(document).on('click', '.page-link', function(){
		
		$("#select-all").prop('checked', false)
		
	})

	$('#select-all').click(function(event) {
	    if (this.checked) {
	      // Iterate each checkbox
		    $(':checkbox').each(function() {
		        this.checked = true;
		    });

		    $('.order-item-id').each(function(key, value){
				if (array_order_item_id.includes(value.value) == false) {
					array_order_item_id.push(value.value)
				}
			})

	    } else {
	      $(':checkbox').each(function() {
	        this.checked = false;
	      });
	    }


	});


	$(document).on('keyup change', '.trigger', function(e) {
	  	var rowTr = $(this).parents('tr');
	  	var weight_tree = rowTr.find('.weight-tree').val();
			var total_weight_tree = rowTr.find('.total-weight-tree').val();
			var weight_gold_1 = total_weight_tree-weight_tree;
			console.log(weight_gold_1)
			var stone_quantity = rowTr.find('.stone-quantity').val();
			var stone_weight = rowTr.find('.stone-weight').val();
			var multiplier = rowTr.find('.multiplier').val();

    	if (stone_weight == '') {
    		stone_weight = 0;
    	}

      var gold_weight = rowTr.find('.gold-weight').val((weight_gold_1-stone_weight)*multiplier);

	});

	$('.submit-select-order-item').submit(function(e){
		e.preventDefault()

		btn = $('.submit-select-order-item button[type="submit"]').html();

		resultOI = array_order_item_id.join();

		$.ajax({
          type : 'get',
          url : '<?= base_url() ?>/batch?act=orderItemByCheck&order_item_id='+resultOI,
          dataType : 'JSON',
          processData: false,
          contentType: false,
          beforeSend : function(){
            $('.submit-select-order-item button[type="submit"]').attr('data-kt-indicator', 'on');
            $('.submit-select-order-item button[type="submit"]').attr('disabled', '');
            $('.submit-select-order-item button[type="submit"]').html('<span class="indicator-progress">\
                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            $('.submit-select-order-item button[type="submit"]').removeAttr('disabled', '');
            $('.submit-select-order-item button[type="submit"]').removeAttr('data-kt-indicator');
            $('.submit-select-order-item button[type="submit"]').html(btn);
          },
          success: function(response){
          	if (response.error) {
              return alertToastr('error', response.error);
            }else if(response.success){
              return alertToastr('success', response.success);
            }

          	 $('#response-data-order').html(response.data)
          	 $('#kt_modal_1').modal('hide')

          },
          error: function (xhr, ajaxOptions, thrownError){
            console.log(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }
        });
	})

$(document).ready(function(){
	"use strict";

		// Class definition
		var KTDatatablesServerSide = function () {
	    // Shared variables
	    var table;
	    var dt;

	    // Private functions
	    var initDatatable = function () {
	        dt = $("#kt_datatable_material").DataTable({
	            responsive:false,
	            // searchDelay: 500,
	            processing: true,
	            serverSide: true,
	            ordering: false,
	            select: {
	                style: 'os',
	                selector: 'td:first-child',
	                className: 'row-selected'
	            },
	            ajax: {
	                url: "<?= base_url() ?>/batch-item-request/0",
	            },
	            columns: [
	                {data: 'no'},
	                {data: 'item_sku'},
	                {data: 'item_source'},
	                {data: 'item_name'},
	                {data: 'item_quantity'},
	                {data: 'input_item_weight'},
	                {data: 'status'},
	            ],
	        });

	        table = dt.$;

	        // Re-init functions on every table re-draw -- more info: https://datatables.net/reference/event/draw
	        dt.on('draw', function () {
	            initToggleToolbar();
	            toggleToolbars();
	            KTMenu.createInstances();
	        });
	    }

	    var handleSearchDatatable = function () {
	        const filterSearch = document.querySelector('[data-kt-docs-table-filter="search"]');
	        filterSearch.addEventListener('keyup', function (e) {
	            dt.search(e.target.value).draw();
	        });
	    }

	    // Init toggle toolbar
	    var initToggleToolbar = function () {
	        const container = document.querySelector('#kt_datatable_material');
	        const checkboxes = container.querySelectorAll('[type="checkbox"]');

	        // Toggle delete selected toolbar
	        checkboxes.forEach(c => {
	            // Checkbox on click event
	            c.addEventListener('click', function () {
	                setTimeout(function () {
	                    toggleToolbars();
	                }, 50);
	            });
	        });
	    }

	    // Toggle toolbars
	    var toggleToolbars = function () {
	        // Define variables
	        const container = document.querySelector('#kt_datatable_material');
	        const toolbarBase = document.querySelector('[data-kt-docs-table-toolbar="base"]');
	        const toolbarSelected = document.querySelector('[data-kt-docs-table-toolbar="selected"]');
	        const selectedCount = document.querySelector('[data-kt-docs-table-select="selected_count"]');

	        var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
	        var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
	            return new bootstrap.Tooltip(tooltipTriggerEl)
	        })

	    }

		    // Public methods
		    return {
		        init: function () {
		            initDatatable();
		            handleSearchDatatable();
		            initToggleToolbar();
		        }
		    }
		}();

		// On document ready
		KTUtil.onDOMContentLoaded(function () {
		    KTDatatablesServerSide.init();
		});
	});

$(document).on('click', '.kt_modal_1_detail', function(){

		let id = $(this).data('id');

		$.ajax({
			type: 'POST',
			url: "<?= base_url() ?>/batch-item-request/"+id+"?batch=<?= @$batchID ?>&param_type=checkApprove",
	    dataType : 'JSON',
	    success: function(response){
	    		console.log(response)
	    	if(response.status == true){
					$('#kt_datatable_material').DataTable().ajax.url("<?= base_url() ?>/batch-item-request/"+id).load();
					$('#kt_modal_1').modal('show');
	    	}else{
	    		alertToastr('error', response.error);
	    	}
	    },
	 })
})
</script>
<?= $this->endSection() ?>

