<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Edit</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/order" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<form action="" class="submit" enctype="multipart/form-data">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
									<div class="form-group my-3 col-md-7">
										<label>Nota</label>
										<input type="text" readonly="" name="note" value="<?= $data->note ?>" class="form-control mt-1 form-control-solid" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Pelanggan</label>
										<input name="customer_id" readonly="" value="<?= $data->customer_name ?>" class="form-control form-control-solid mt-1" placeholder="">
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Tanggal</label>
										<input type="date" name="date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Batas Waktu Tanggal</label>
										<input type="date" name="due_date" value="<?=  date('Y-m-d') ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-7">
										<label>Deskripsi</label>
										<input type="text" value="<?=  $data->description ?>" name="description" class="form-control mt-1" placeholder=""/>
									</div>
									<?php if ($data->status != 'Completed'): ?>
									<div class="form-group my-3 col-md-7">
										<label>Status</label>
										<select name="status" class="form-control mt-1" placeholder="">
											<option selected="" value="<?=  $data->status ?>"><?=  $data->status ?></option>
											<option value="Completed">Completed</option>
										</select>
									</div>
									<?php endif ?>
									<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
								</div>
								<!--end: Card Body-->
							</div>
							<div id="item-list">
								<?php foreach ($data_order_item as $key => $value): ?>
									<div class="card card-xxl-stretch mb-5 item-card">
								<div class="card-body">
									<div class="row">
												<div class="form-group my-3 col-md-4">
													<label>SKU</label>
													<input readonly="" type="text" name="sku[]"  value="<?= $value->sku?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<input type="hidden" name="id[]" value="<?= $value->id?>">
													<label>Nama</label>
													<input readonly="" type="text" name="name[]"  value="<?= $value->name?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Kategori</label>
													<input readonly="" type="hidden" name="category_id[]" value="<?=$value->category_id?>" class="form-control form-control-solid mt-1" >
													<input readonly="" type="text"  value="<?= $value->category_name?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Kadar Emas</label>
													<input readonly="" name="gc_id[]" type="hidden" value="<?= $value->gc_id?>" class="form-control form-control-solid mt-1" placeholder="">
													<input readonly="" type="text"  value="<?= $value->gc_name?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Warna Emas</label>
													<input readonly="" name="gt_id[]" type="hidden" value="<?= $value->gt_id?>" class="form-control form-control-solid mt-1" placeholder="">
													<input readonly="" type="text"  value="<?= $value->gt_name?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Berat</label>
													<input readonly="" type="text" name="weight[]"  value="<?= $value->weight ?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Ukuran</label>
													<input readonly="" name="size_id[]" type="hidden" value="<?= $value->size_id?>" class="form-control form-control-solid mt-1" placeholder="">
													<input readonly=""  value="<?= $value->size_name ?>" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Tipe Batu</label>
													<input readonly="" type="text" value="<?= $value->stone_type ?>" name="stone_type[]" class="form-control form-control-solid mt-1" placeholder="">
												</div>
												<div class="form-group my-3 col-md-4">
													<label>Quantity</label>
													<input type="number" readonly="" value="<?= $value->quantity ?>" name="quantity[]" class="form-control form-control-solid mt-1" placeholder="">
												</div>
										</div>
									</div>
											</div>
								<?php endforeach ?>
										
										<!--end: List Widget 5-->
										</form> 
									</div>
									<!--end::Col-->
							</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->

<?= $this->endSection() ?>