
<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Edit</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/operator" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-xxl-12">
						<!--begin::List Widget 5-->
						<div class="card card-xxl-stretch mb-5">
							<div class="card-body">
								<form action="" class="submit">
									<div class="form-group my-3 col-md-7">
										<label>Nama <?= $title ?></label>
										<input type="text" name="name" value="<?= $data->name ?>" class="form-control mt-1" placeholder=""/>
									</div>
									<div class="form-group my-3 col-md-6">
										<label>List Divisi</label>
									</div>
									<table class="table table-striped table-bordered gs-7">
										<thead>
											<tr>
												<th><input <?= (count($data_operator_task) == count($data_task))? 'checked': '' ?> type="checkbox" value="" id="select-all" name=""></th>
												<th>Nama Task</th>
											</tr>
										</thead>
										<tbody class="draggable-zone">
											<?php 
											$operator_task_array = [];
											foreach ($data_operator_task as $key => $value){
												$operator_task_array[] = $value->task_id;
											}
											?>
											<?php foreach ($data_task as $key1 => $value1): ?>
											<tr>
												<td><input type="checkbox" <?= (in_array($value1->id, $operator_task_array))? 'checked': '';  ?> value="<?= $value1->id ?>" class="select" name="task_id[]"></td>
												<td><?= $value1->name ?></td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>
									<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
								</form> 
							</div>
							<!--end: Card Body-->
						</div>
						<!--end: List Widget 5-->
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->
<?= $this->endSection() ?>


<?= $this->section('js') ?>
<script src="<?= base_url(); ?>/plugins/custom/draggable/draggable.bundle.js"></script>
<script type="text/javascript">


var containers = document.querySelectorAll(".draggable-zone");

// if (containers.length === 0) {
//     return false;
// }

var swappable = new Sortable.default(containers, {
    draggable: ".draggable",
    handle: ".draggable .draggable-handle",
    mirror: {
        //appendTo: selector,
        appendTo: "body",
        constrainDimensions: true
    }
});

	$('#select-all').click(function(event) {
		if (this.checked) {
		  // Iterate each checkbox
		  $('.select').each(function() {
		    this.checked = true;
		  });
		} else {
		  $('.select').each(function() {
		    this.checked = false;
		  });
		}
	});
</script>
<?= $this->endSection() ?>