<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1">Tambah</small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
					<!--begin::Button-->
					<a href="<?= base_url() ?>/order" class="btn btn-sm btn-secondary" >Kembali</a>
					<!--end::Button-->
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<!--begin::Col-->
					<div class="col-md-12">
						<!--begin::List Widget 5-->
						<div class="card mb-2">
							<div class="card-body">
								<form action="<?= base_url('outgoing-batch?act=batchItemData') ?>" class="submit-search">
									<div class="row">
										<div class="form-group my-3 col-md-3">
											<label>Dari Tanggal Proses</label>
											<input type="date" name="from_date" class="form-control mt-1" placeholder=""/>
										</div>
										<div class="form-group my-3 col-md-3">
											<label>Sampai Tanggal Proses</label>
											<input type="date" name="to_date" class="form-control mt-1" placeholder=""/>
										</div>
										<div class="form-group my-3 col-md-3">
											<label>No Order/Batch</label>
											<input type="text" name="note" class="form-control mt-1" placeholder=""/>
										</div>
										<div class="form-group my-3 col-md-2">
											<label>&nbsp;</label>
											<button class="btn btn-warning form-control button">Search</button>
										</div>
									</div>
								</form>
								</div>
								<!--end: Card Body-->
							</div>
							<form action="" class="submit2" enctype="multipart/form-data">
								<div class="card">
									<div class="card-body">

										<div id="response-item"></div>

										<div class="form-group mt-2">
											<label>Keterangan</label>
											<textarea name="remark" style="width: 400px;" class="form-control"></textarea>
										</div>
										<button type="submit" class="btn btn-primary mt-3 button">Simpan</button>
									</div>
								</div>

							</form> 
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->

<?= $this->endSection() ?>

<?= $this->section('js') ?>
	<script type="text/javascript">

		$("#item-list").on('click', '.remove-item', function(e) {
        var yes = confirm('Are you sure delete this?');
        if (yes) {
            $(this).parents('.item-card').remove();
        } else {
            return false;
        }
    })

	let noindex = 0;	
		
	$('.submit-search').submit(function(e){

		e.preventDefault();

		var divisi = $('select[name="task_id"]').val();
		var thisData = $(this);
		btn = thisData.find('.button').html();
		

			$.ajax({
          type : 'POST',
          url : thisData.attr('action'),
          data : thisData.serialize(),
          dataType : 'JSON',
          beforeSend : function(){
            thisData.find('.button').attr('data-kt-indicator', 'on');
            thisData.find('.button').attr('disabled', '');
            thisData.find('.button').html('<span class="indicator-progress">\
                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            thisData.find('.button').removeAttr('disabled', '');
            thisData.find('.button').removeAttr('data-kt-indicator');
            thisData.find('.button').html(btn);
          },
          success: function(response){

          	if(response.success){
              $('#response-item').html(`<table class="table table-row-bordered">
											<thead>
												<tr>
													<td>Nama Barang</td>
													<td>Nota</td>
													<td>Barcode</td>
													<td>Ket</td>
													<td>Jumlah</td>
													<td>Berat</td>
													<td>Pilih</td>
												</tr>
											</thead>
											<tbody> 
												${response.success}
											</tbody>
										</table>`)
            }else {
            	alertToastr('error', response.error);
							$('#response-item').html(``);
            }

          },
          error: function (xhr, ajaxOptions, thrownError){
            alert(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }

        });

	})



	$(document).on('click', '#button-plus-list-', function(){

		$('.btn-list-').removeClass('btn-success');
		$('.btn-list-').addClass('btn-danger');

		$('.btn-list-').attr('id', 'button-minus-list-');

		$('.btn-icon-').removeClass('fa-plus');
		$('.btn-icon-').addClass('fa-minus');

			$('#list-result-').append(`
							<tr>
								<td><input class="form-control" type="text" name="names[]"></td>
								<td><input class="form-control" type="number" step="any" name="quantities[]"></td>
								<td><input class="form-control" type="number" step="any" name="weights[]"></td>
								<td>
									<button class="btn btn-success btn-list-" type="button" id="button-plus-list-"><i class="fa fa-plus btn-icon-"></i></button>
								</td>
							</tr>`)
	})
	
	$(document).on('click', '#button-minus-list-', function(){
		$(this).parents('tr').remove()
	})

	$('.submit2').submit(function(e){    
    e.preventDefault();

    var data = new FormData(this);
	$.each($(".image").files, function(i, files) {
		$.each(files, function(idx, file) {
	    	data.append('image'+idx, file);
		})
	});

	// var	project_thumbnail = $(".image").prop("files")[0];

	// var data = new FormData( $("#general_form")[0] );
	// 	data.append('image',project_thumbnail);

		//CHECK ALIF//
		var data = new FormData();
		$('input[name="batch_item_output[]"]').each(function () {
			if (this.checked){
				data.append('batch_item_output[]',$(this).val());
				data.append('batch_item_quantity[]',$(this).data("quantity"));
				data.append('batch_item_weight[]',$(this).data("weight"));
			}
		});
		data.append('remark',$('textarea[name=remark]').val());

    var btn = $('.button').html();

    var search_data = $('.submit-search').serialize();
    
    $.ajax({
          type : 'post',
          url : '<?= base_url('outgoing-batch/create') ?>'+'?'+search_data,
          data : data,
          dataType : 'JSON',
          processData: false,
          contentType: false,
          beforeSend : function(){
            $('.button').attr('data-kt-indicator', 'on');
            $('.button').attr('disabled', '');
            $('.button').html('<span class="indicator-progress">\
                        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
                    </span>');
          },
          complete : function(response){
            $('.button').removeAttr('disabled', '');
            $('.button').removeAttr('data-kt-indicator');
            $('.button').html(btn);
          },
          success: function(response){
             if (response.error) {
              alertToastr('error', response.error);
            }else if(response.success){
              alertToastr('success', response.success);
            }

            if (response.redirect) {
              window.location.href = '<?= base_url() ?>/'+response.redirect
            }else{
              $('#kt_datatable').DataTable().ajax.reload();
            }

          },
          error: function (xhr, ajaxOptions, thrownError){
            alert(xhr.status + "\n"+ xhr.responseText+"\n"+thrownError)
          }

      });
  });


</script>
<?= $this->endSection() ?>